.TH Command SPY
.SY "spy <SPIES> [subcommand] [args]..."
After using the `recruit' command to train spies, 
you use the `spy' command to direct their covert activities.
.s3
The `spy' command can be used in many ways, enabling your spies
to perform a number of functions normally available only to the
owner of the ship or sector.  Your spies can be moved in foreign
land or sneaked aboard foreign vessels, where they can reveal, in 
estimated numbers, census and commodity reports, distribution paths 
and levels, crew and cargo reports, and the presence of ships, planes, 
and other vehicles.  Additionally, spies can be used to steal small
quantities of commodities, blow up select commodities in their current
location, liquidate individuals (including themselves), and reconnoiter
surrounding territory.
.s3
.NF
   spy <id>                 Personal statistics.

       Shows spy type, name, coordinates, whether or not location is
       abroad, efficiency, mobility, age, tech, education, happiness, 
       and pilot training levels.  Also shows calculated accuracy 
       percentage.

   spy <id> report          General info about current location.

   spy <id> move <path>     Move around.

       Syntax is similar to `explore' command.

   spy <id> census          Produce an estimated census report.

   spy <id> commodities     Produce an estimated commodities report.

   spy <id> cargo           Produce an estimated cargo report.

   spy <id> level           Estimate distribution information.

   spy <id> recon           Report what's probably in surrounding sectors.

   spy <id> planes          Report planes in the sector.

   spy <id> ships           Report ships in the sector.

   spy <id> tanks           Report tanks in the sector.

   spy <id> balloons        Report balloons in the sector.

   spy <id> trains          Report trains in the sector.

   spy <id> kill <m|c|u|id> Attempt to liquidate one mil, civ, uw, or spy.

   spy <id> look            Produce a map showing neighboring sectors.

   spy <id> board <shipid>  Attempt to board a ship or vehicle.

       Almost any ship or vehicle can be boarded, regardless of who
       owns it.  The chance of being detected or caught depends on the
       number of crew already aboard and the efficiency of the ship or
       vehicle.

   spy <id> leave [dir]     Leave a ship or vehicle.

       This is just the opposite of `board', causing your spy to leave
       the vessel or vehicle he is currently aboard.  If he is aboard a
       vehicle that is being transported aboard a ship, `leave' will
       cause him to end up aboard the transporting ship.  If the vessel
       is at sea, `leave' can be used to land a spy on an adjacent
       shore by using the optional [dir] parameter to specify the
       direction in which to drop him off.

   spy <id> steal <plane>   Steal an aircraft.

       Any spy can be used to steal aircraft, but first the spy must
       undergo pilot training.  This is done leaving the spy in an
       airport sector.  In a home airport, at each update his pilot
       skill level will increase by an amount equal to one plus his
       education level, times the number of etus per update divided by
       three.  In foreign airports, the rate is 1/4 as fast.  Pilot
       training level grows to match the tech rating of the most tech
       nically advanced plane in that sector.  Attempting to fly an
       aircraft of higher tech than the pilot's training level allows
       can be suicidal.

   spy <id> take <comm>     Take a commodity.

       Spies can carry almost any two commodities, but only one sample
       of any any single commodity.  The commodity may come from from
       the current sector, or from a ship's or vehicle's cargo.
       Task difficulty factor depends on the commodity being taken:

	         5 civilians    5 iron         5 lcms
	        35 military    15 dust         5 hcms
	        60 shells      80 bars        25 uranium
	        60 guns         5 food        65 rads
	        50 petrol      20 oil       

   spy <id> drop <comm>     Drop a commodity.

       Deposits a commodity in the current location.

   spy <id> bomb <comm>     Attempt to bomb a specific commodity.

       Spy must possess one shell, which he very accurately places and
       detonates in the storage place of a specific commodity.  This
       can effect some collateral damage in addition to large pinpoint
       damage, with damage more severe for explosions aboard ships and
       vehicles.  Bombs can also lead to secondary explosions when the
       target itself is volatile or explosive.  Task difficulty factor
       depends on the commodity being bombed:

	         5 civilians    5 iron         5 lcms
	        35 military    15 dust         5 hcms
	        60 shells      80 bars        25 uranium
	        60 guns         5 food        65 rads
	        50 petrol      20 oil       

   spy <id> give <cnum>     Give a spy to another country.

       Cost is 20 mobility, and a 20% drop in efficiency.  (Mobility
       will not drop below 0; efficency will not drop below 25%.)
	
   spy <id> retire          Quit the spy force and rejoin local military.

       The spy ceases to exist; his current location gains one mil.
       Spies on foreign soil or aboard manned foreign vehicles cannot
       quit.  If you quit aboard an unmanned foreign vessel, the vessel
       becomes yours.  If the spy is more than halfway to retirement, a
       portion of his pension is considered vested and he will be paid
       an appropriate 50, 60, 70, 80, 90, or 100 percent of his retire-
       ment pension.
.FI
.s3
Generally, each spy command first pits the spy's accuracy and intelligence
against the target country's intelligence, technology, and military presence.
Depending on the outcome, the spy may be detected, shot at, killed, or go
unnoticed.  In the latter case, the requested assignment is carried out.
.s3
A spy's accuracy may change at each update and depends on a number of factors:
.s3
.NF
    *  his efficiency, tech, education, happiness, and age
    *  his homeland's happiness, education, and tech levels
    *  the host country's happiness, education, and tech levels
    *  what kind of sector he is in
.FI
.s3
Personal levels increase various amounts depending largely on
where the spy is located:
.NF

               ---------------AMOUNT OF GAIN PER UPDATE---------------
   LOCATION    HAPPINESS    TECH    EDUCATION   PILOTSKILL  EFFICIENCY

       Fort                            +2%                     etus
    Capitol                            +2%                     etus
       Park       +10%                                         etus
   Airfield                                    etus*(Edu+1)   etus/2
     School                            +5%                    etus/2
Tech Center                  +5%                              etus/2
      Other                                                   etus/2
.FI
.s3
Personal levels also frequently move some degree 
toward local national levels.  Tech and education naturally rise, 
regardless of location, toward the local levels wherever he happens 
to be.  The increase rate is greater at home than aboard (information 
at home is more readily available and easier learned). 
.s3
Certain task outcomes may cause drops in happiness.
Personal happiness level determines degree of job satisfaction, which 
in turn determines whether a spy will choose to continue to work, resign,
defect, or simply vanish.
.s3
Spies are paid according to a typical complex bureaucratic salary 
formula which takes into account a number of factors.  First, he
receives his base pay, which is then modified by a number of bonuses
and reductions:
.NF

      base pay = (etus * spy_cost * .11111 / 250.0)

      +  5% if he's on foreign soil

      +  5% if it's non-POGO foreign soil

      +  20% if he's extremely smart (i.e., national edu level is less
         than 85% of the spy's level)

      +  15% if he knows how to use high-tech toys (i.e., national tech
         level is less than 85% of the spy's level)

      -  Docked 5% if he's not too smart (i.e., spy's edu level is less
         than 85% of the national level)

      -  Docked 5% if he's technically deficient (i.e., spy's tech
         level is less than 85% of the national level)

      -  Takes a 10% cut if he's overly happy (i.e., national happiness
         level is less than 85% of the spy's level)

.FI
.s3
Each spy's age increases by one at each update; mandatory retirement 
happens when age exceeds 2800 divided by the number of etus per update.
Upon retirement, a spy receives an appropriate retirement pension.
(You can use the `version' command to learn the exact retirement age
and pension values.)
.s3
See also : recruit, find
