static char *RCSid = "$Header: /sequent2/empire/EMP/lib/global/RCS/sect.c,v 1.1 89/09/02 18:30:23 mr-frog Exp $";

/*
 * sect.c
 *
 * sector designation characteristics -- one entry per
 * designation type
 * order must agree with sect.h
 */

#include "misc.h"
#include "sect.h"
#include "product.h"

struct  dchrstr dchr[SCT_MAXDEF+2]  = {
/*      mnem        prd    mcst  flg     pkg ostr dstr value name    */

	DCH_WATER,  0,        0, NAVOK,  NPKG,  0,   0,   0, "sea",
	DCH_MOUNT,  0,      127, 0,      NPKG,  2,  16,   5, "mountain",
	DCH_SANCT,  0,        0, 0,      NPKG,  0,  99, 127, "sanctuary",
	DCH_WASTE,  0,        0, 0,      NPKG,  0,  99,   0, "wasteland",
	DCH_RURAL,  0,        4, 0,      NPKG,  2,   2,   1, "wilderness",
	DCH_CAPIT,  0,        2, 0,      NPKG,  2,   4,  30, "capitol",
	DCH_URAN,   P_URAN,   2, 0,      NPKG,  2,   3,  15, "uranium mine",
	DCH_PARK,   P_HLEV,   2, 0,      NPKG,  2,   2,   5, "park",
	DCH_ARMSF,  P_GUN,    2, 0,      NPKG,  2,   2,   7, "defense plant",
	DCH_AMMOF,  P_SHELL,  2, 0,      NPKG,  2,   2,   6, "shell industry",
	DCH_MINE,   P_IRON,   2, 0,      NPKG,  2,   3,   5, "mine",
	DCH_GMINE,  P_DUST,   2, 0,      NPKG,  2,   3,   8, "gold mine",
	DCH_HARBR,  0,        2, NAV_02, NPKG,  2,   2,  12, "harbor",
	DCH_WAREH,  0,        2, 0,      WPKG,  2,   2,   7, "warehouse",
	DCH_AIRPT,  0,        2, 0,      NPKG,  2,   1,  12, "airfield",
	DCH_AGRI,   P_FOOD,   2, 0,      NPKG,  2,   2,   2, "agribusiness",
	DCH_OIL,    P_OIL,    2, 0,      NPKG,  2,   2,   5, "oil field",
	DCH_LIGHT,  P_LCM,    2, 0,      NPKG,  2,   2,   3, "light manufacturing",
	DCH_HEAVY,  P_HCM,    2, 0,      NPKG,  2,   2,   4, "heavy manufacturing",
	DCH_FORTR,  0,        2, 0,      NPKG,  4,   8,  10, "fortress",
	DCH_TECH,   P_TLEV,   2, 0,      NPKG,  2,   2,  10, "technical center",
	DCH_RSRCH,  P_RLEV,   2, 0,      NPKG,  2,   2,   9, "research lab",
	DCH_NUKE,   0,        2, 0,      NPKG,  2,   3,  10, "nuclear plant",
	DCH_LIBR,   P_ELEV,   2, 0,      NPKG,  2,   2,   4, "library/school",
	DCH_HIWAY,  0,        1, 0,      NPKG,  1,   1,   3, "highway",
	DCH_RADAR,  0,        2, 0,      NPKG,  2,   2,   4, "radar installation",
	DCH_WETHR,  0,        2, 0,      NPKG,  2,   2,   1, "weather stn (useless)",
	DCH_BHEAD,  0,        1, 0,      NPKG,  2,   2,   4, "bridge head",
	DCH_BSPAN,  P_FOOD,   1, NAV_60, NPKG,  1,   1,   5, "bridge span",
	DCH_BANK,   P_BAR,    2, 0,      BPKG,  2,   3,  10, "bank",
	DCH_REFINE, P_PETROL, 2, 0,      NPKG,  2,   2,   2, "refinery",
	DCH_ENLIST, 0,        2, 0,      NPKG,  2,   3,   7, "enlistment center",
	DCH_TANK,   0,        2, 0,      NPKG,  2,   2,  12, "tank farm",
	DCH_TRADE,  0,        2, NAV_02, WPKG,  2,   2,   6, "trade center",
/*
**      mnem prd     mcst  flg    pkg ostr dstr value name
**
**      Still unused:     q v y & , ; : / < > { } ( _ 
*/
	0,   0,        0, 0,      0,     0,   0,   0, 0,
};
