#ifndef lint
static char *RCSid = "$Header: candidate.c,v 1.1 89/12/14 12:32:11 jay Exp $";
#endif

/*
 * candidate.c
 *
 * get a new candidate
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "sailio.h"
#include "login.h"
#include "tm.h"
#include "proto.h"

#include <sys/socket.h>
#include <netinet/in.h>

struct	candidate *candidates;
int	maxcandidates;

cd_init()
{
	extern	int errno;

	maxcandidates = getfdtablesize() - 4;
	logerror("max candidates is %d", maxcandidates);
	candidates = (struct candidate *)
		malloc(sizeof(*candidates) * maxcandidates);
	bzero(candidates, sizeof(*candidates) * maxcandidates);
}

struct candidate *
cd_new(d)
	int	d;
{
	register struct candidate *cp;
	struct	sockaddr_in sin;
	int	foo;
	int	ns;
	int	set = 1;

	foo = sizeof(sin);
	ns = accept(d, (struct sockaddr *) &sin, &foo);
	if (ns < 0) {
		logerror("new socket accept");
		return 0;
	}
	(void) setsockopt(ns, SOL_SOCKET, SO_KEEPALIVE, &set, sizeof(set));
	if (ns >= maxcandidates) {
		close(ns);
		logerror("new fd %d, max fd %d, no fd's left for new user!",
			ns, maxcandidates);
		return 0;
	}
	cp = &candidates[ns];
	strcpy(cp->remhost, inet_ntoa(sin.sin_addr));
	if ((cp->iop = sopen(ns)) == 0) {
		(void) close(ns);
		logerror("sopen failed");
		return 0;
	}
	sendclient(cp->iop, C_INIT, "Empire server ready");
	sflush(cp->iop);
	cp->cnum = -1;
	*cp->countryname = 0;
	*cp->password = 0;
	*cp->remuser = 0;
	cp->cmd = 0;
	cp->state = 0;
	return cp;
}

struct candidate *
cd_byfd(fd)
	int	fd;
{
	return &candidates[fd];
}

cd_delete(cp)
	struct	candidate *cp;
{
	extern	int iswatching;

	if (cp->iop)
		sclose(cp->iop);
	bzero(cp, sizeof(*cp));
	if (iswatching)
		dowatch();
	return 0;
}

struct candidate *
cd_next(cp)
	struct	candidate *cp;
{
	if (cp == 0)
		return &candidates[0];
	cp++;
	if (cp >= &candidates[maxcandidates])
		return 0;
	return cp;
}
