#ifndef lint
static char *RCSid = "$Header: main.c,v 1.1 89/12/14 12:32:16 jay Exp $";
#endif /* not lint */

/*
 * main.c
 *
 * main command loop and initialization
 * for empire login server
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "bit.h"
#include "proto.h"
#include "sailio.h"
#include "login.h"
#include "file.h"

#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <netdb.h>
#include <netinet/in.h>
#include <signal.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <fcntl.h>

#ifndef SIGCHLD
#define SIGCHLD SIGCLD
#endif

char	*program = "login";

int	(*leprfunc)();		/* logerror pr function, == NULL */

main()
{
	extern	char loginport[];
	int	cleanchild();
	extern	int errno;
	register struct candidate *cp;
	struct	sockaddr_in sin;
	struct	servent *sp;
	int	s;
	short	port;
	int	val;
	bit_fdmask mask;
	bit_fdmask savemask;
	int	fd_max;
	int	fd;

#ifndef DEBUG
	disassoc();
#endif
	(void) signal(SIGCHLD, cleanchild);
	(void) signal(SIGINT, SIG_IGN);
#ifdef SIGTSTP
	(void) signal(SIGTSTP, SIG_IGN);
#endif
	(void) signal(SIGHUP, SIG_IGN);
#ifdef notdef
	setfdtablesize(32, 256);
#endif
	sp = getservbyname("empire", "tcp");
	if (sp == 0)
		port = htons(atoi(loginport));
	else
		port = sp->s_port;
	sin.sin_addr.s_addr = INADDR_ANY;
	sin.sin_port = port;
	sin.sin_family = AF_INET;
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		logerror("inet socket create");
		exit(1);
	}
	val = 1;
	if (setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &val, sizeof(val)) < 0) {
		logerror("inet socket setsockopt SO_REUSEADDR");
		exit(1);
	}
	if (bind(s, (struct sockaddr *) &sin, sizeof(sin)) < 0) {
		logerror("inet socket bind");
		exit(1);
	}
	if (listen(s, 5) < 0) {
		logerror("inet socket listen");
		exit(1);
	}
	lo_init();
	cd_init();
	mask = bit_newfdmask();
	savemask = bit_newfdmask();
	BIT_SETB(s, savemask);
	ef_open(EF_NATION, O_RDONLY, EFF_MEM);
	logerror("server started, pid %d", getpid());
	fd_max = s;
	while (1) {
		bit_copy(savemask, mask);
		if (select(fd_max+1, mask, 0, 0, 0) <= 0) {
			if (errno == EINTR) {
				errno = 0;
				continue;
			} else {
				logerror("main loop select; terminating");
				break;
			}
		}
		if (BIT_ISSETB(s, mask)) {
			if ((cp = cd_new(s)) == 0) {
				logerror("newuser failed");
				continue;
			}
			if (sio_fileno(cp->iop) > fd_max)
				fd_max = sio_fileno(cp->iop);
			BIT_SETB(sio_fileno(cp->iop), savemask);
			BIT_CLRB(s, mask);
		}
		while ((fd = bit_fd(mask)) >= 0) {
			if ((cp = cd_byfd(fd)) == 0) {
				logerror("no candidate to match fd %d\n", fd);
				close(fd);
				BIT_CLRB(fd, savemask);
				BIT_CLRB(fd, mask);
				continue;
			}
			/*
			 * if service returns true, then the
			 * user has left for the game and is
			 * currently logged in
			 */
			if (service(cp))
				BIT_CLRB(fd, savemask);
			BIT_CLRB(fd, mask);
		}
	}
	close(s);
}

int
cleanchild()
{
	extern	char *signame();
	union	wait w;
	struct	login *lp;
	int	pid;

	while ((pid = wait3(&w, WNOHANG, (struct rusage *)0)) > 0) {
		if ((lp = lo_find(pid)) == 0) {
			logerror("got sigchld from a non-user child (%d)", pid);
		} else
			lo_delete(lp);
		if (w.w_termsig)
			logerror("child terminated on signal; %s%s",
				signame(w.w_termsig),
				w.w_coredump ? " (core dumped)" : "");
		else if (w.w_retcode)
			logerror("child exited: return %d", w.w_retcode);
	}
#ifdef sys5
	(void) signal(SIGCHLD, cleanchild);
#endif
	return 0;
}
