#ifndef lint
static char *RCSid = "$Header: buil.c,v 1.1 89/12/14 08:19:18 jay Exp $";
#endif /* not lint */

/*
 * buil.c
 *
 * version 3.0
 * build ships, nukes, bridges, planes.
 *
 * from PSL Empire, 1985
 */

/* Since they're only used within this module, the following
   can be anything as long as they don't conflict with any of 
   the CLASS definitions in ship.h */
#define CLASS_PLANE  909
#define CLASS_NUKE   910
#define CLASS_BRIDGE 911

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "nat.h"
#include "ship.h"
#include "nuke.h"
#include "plane.h"
#include "xy.h"
#include "nsc.h"
#include "treaty.h"
#include "deity.h"
#include "file.h"
#include "path.h"

extern double nuke_cost_multiplier;
extern double nuke_tech_multiplier;
extern double plane_cost_multiplier;
extern double plane_tech_multiplier;
extern double ship_cost_multiplier;
extern double ship_tech_multiplier;

static struct mchrstr *askshiptype();
static struct plchrstr *askplanetype();
static struct nchrstr *asknuketype();
static int build_nuke();
static int build_ship();
static int build_bridge();
static int build_plane();

static	int cash;

/*
 * build <WHAT> <SECTS> <TYPE|DIR|MEG>
 */
buil()
{
    extern	char *argp[];
    extern  double buil_bt;
    extern	double dolcost;
    struct	sctstr sect;
    struct	nstr_sect nstr;
    struct	natstr *natp;
    int	rqtech;
    int	tlev;
    int	n;
    int	type;
    int	what;
    struct	mchrstr *mp;
    struct	plchrstr *pp;
    struct	nchrstr *np;
    char	*p;
    int	vec[I_MAX+1];
    char	linebuf[80];
    char	*buildtech;
    int	gotsect = 0;
    int	built;
    natid forwhom;
    
    natp = getnatp(cnum);
    cash = natp->nat_money;
    strcpy(linebuf,"Build (ship");
#ifdef NUKES
    strcat(linebuf,", nuke");
#endif
    strcat(linebuf,", bridge");
#ifdef PLANES
    strcat(linebuf,", plane");
#endif
#ifdef BALLOONS
    strcat(linebuf,", balloon");
#endif
#ifdef TANKS
    strcat(linebuf,", tank");
#endif
#ifdef TRAINS
    strcat(linebuf,", train");
#endif
    strcat(linebuf,")? ");

    if (!(p=getstarg(argp[1],linebuf))) return RET_SYN;

    if (!snxtsct(&nstr, argp[2])) {
	pr("Bad sector specification.\n");
	return RET_SYN;
    }

    if      (patmat(p,"s*", 1)) what = CLASS_SHIP;

#ifdef PLANES
    else if (patmat(p,"p*", 1)) what = CLASS_PLANE;
#endif

#ifdef NUKES
    else if (patmat(p,"n*", 1)) what = CLASS_NUKE;
#endif

#ifdef BALLOONS
    else if (patmat(p,"ba*",1)) what = CLASS_BALLOON;
    else if (patmat(p,"br*",1)) what = CLASS_BRIDGE;
#else
    else if (patmat(p,"b*", 1)) what = CLASS_BRIDGE;
#endif

#ifdef TANKS
#ifdef TRAINS
    else if (patmat(p,"ta*",1)) what = CLASS_TANK;
    else if (patmat(p,"tr*",1)) what = CLASS_TRAIN;
#else
    else if (patmat(p,"t*", 1)) what = CLASS_TANK;
#endif
#else
#ifdef TRAINS
    else if (patmat(p,"t*", 1)) what = CLASS_TRAIN;
#endif
#endif

    else {
	pr("You can't build that!\n");
	return RET_FAIL;
    }

    buildtech = argp[4];
ask_again:
    tlev = (int) natp->nat_level[NAT_TLEV];
    switch (what) {
    case CLASS_BRIDGE:
	if (tlev >= buil_bt) break;
	pr(fmt("Building a span requires a tech of %.0f\n",buil_bt));
	return 2;
    case CLASS_PLANE:
	if (!(pp=askplanetype(argp[3],tlev))) return RET_SYN;
	rqtech = (int)((double)pp->pl_tech*plane_tech_multiplier);
	break;
    case CLASS_NUKE:
	if (!(np=asknuketype(argp[3],tlev))) return RET_SYN;
	rqtech = (int)((double)np->n_tech*nuke_tech_multiplier);
	break;
    default:
	if (!(mp=askshiptype(what,argp[3],tlev))) return RET_SYN;
	rqtech = (int)((double)mp->m_tech*ship_tech_multiplier);
	break;
    }

    if (what!=CLASS_BRIDGE && what!=CLASS_NUKE) {
	char bstr[45];
	(void) sprintf(bstr,"Build at what tech (%d)? ",
		       (int) natp->nat_level[NAT_TLEV]);
	p = getstarg(buildtech, bstr);
	if (!p) return RET_FAIL;
	if (*p) {
	    if (*p == '.') tlev = natp->nat_level[NAT_TLEV];
	    else tlev = atopi(p);
	    if (tlev > natp->nat_level[NAT_TLEV] && !god) {
		pr(fmt("Your tech level is only %d\n",
		       (int)natp->nat_level[NAT_TLEV]));
		buildtech = (char *)0;
		goto ask_again;
	    }
	    if (rqtech > tlev) {
		pr(fmt("Required tech is %d\n",rqtech));
		buildtech = (char *)0;
		goto ask_again;
	    }
	    pr(fmt("Building with tech level %d\n", tlev));
	}
    }

    forwhom = cnum;
    if (god)
	if ((forwhom=natarg(argp[5],"Build for whom? ")) <= 0) forwhom = 0;

    while (nxtsct(&nstr, &sect)) {
	gotsect++;
	if (!owner) continue;
	if (sect.sct_effic < 60 && !god) continue;
	getvec(VT_ITEM, vec, (char *)&sect, EF_SECTOR);
	switch (what) {
	case CLASS_NUKE: 
	    built = build_nuke(&sect, np, vec, forwhom); 
	    break;
	case CLASS_PLANE:  
	    built = build_plane(&sect, pp, vec, tlev, forwhom);
	    break;
	case CLASS_BRIDGE:
	    built = build_bridge(&sect, vec, forwhom);
	    break;
	default: 
	    built = build_ship(&sect, mp, vec, tlev, forwhom);
	    break;
	}
	if (built) {
	    putvec(VT_ITEM, vec, (char *)&sect, EF_SECTOR);
	    putsect(&sect);
	}
    }

    if (!gotsect) pr("Bad sector specification.\n");
    return RET_OK;
}

static struct nchrstr *asknuketype(s,tlev)
char *s;
{
    char *p;
    int type,n;
    struct nchrstr *np;
    type = N_MAXNUKE+1;
    while (type >= N_MAXNUKE) {
	p = getstarg(s,"Nuke type? "); 
	if (!p || !*p) return 0;
	s = (char *)0;
	n = strlen(p);
	for (np = nchr, type=0; type < N_MAXNUKE; type++, np++) {
	    if (np->n_tech > tlev && !god) continue;
	    if (!strncmp(p, np->n_name, n)) break;
	}
	if (type >= N_MAXNUKE) {
	    pr("Possible nuke types are:\n");
	    show_nuke_build(tlev);
	}
    }
    return(np);
}

static struct plchrstr *askplanetype(s,tlev)
char *s;
{
    char *p;
    int type,n;
    struct plchrstr *pp;
    type = pln_maxno+1;
    while (type > pln_maxno) {
	p = getstarg(s,"Plane type? ");
	if (!p || !*p) return 0;
	s = (char *)0;
	n = strlen(p);
	for (pp = plchr, type=0; type <= pln_maxno; type++, pp++) {
	    if (pp->pl_tech > tlev && !god) continue;
	    if (!strncmp(p, pp->pl_name, n)) break;
	}
	if (type > pln_maxno) {
	    pr("Possible plane types are:\n");
	    show_plane_build(tlev);
	}
    }
    return(pp);
}

static struct mchrstr *askshiptype(c,s,tlev)
char *s;
int c;
{
    char *p;
    int type,n;
    struct mchrstr *mp;
    type = shp_maxno+1;
    if (c<0 || c>=NUM_CLASSES) return 0;
    while (type > shp_maxno) {
	p = getstarg(s,fmt("%s type? ",class[c].name));
	if (!p || !*p) return 0;
	s = (char *)0;
	n = strlen(p);
	for (mp = mchr, type=0; type <= shp_maxno; type++, mp++) {
	    if ((mp->m_class != c) || ((mp->m_tech > tlev) && !god)) continue;
	    if (!strncmp(p, mp->m_name, n)) break;
	}
	if (type > shp_maxno) {
	    pr(fmt("Possible %s types are:\n",class[c].name));
	    show_vehicle_build(tlev,c);
	}
    }
    return(mp);
}

static int build_ship(sp, mp, vec, tlev, forwhom)
register struct sctstr *sp;
register struct mchrstr *mp;
register int *vec;
int	tlev;
natid forwhom;
{
	struct	shpstr ship;
	struct	nstr_item nstr;
	int	cost;
	int	w_p_eff;
	int	points;
	char	*where;

	if (!god)
	    if (!stypeinlist(class[mp->m_class].birthplace,sp->sct_type)) {
		pr(fmt("You build %ss in %s.\n",
		       class[mp->m_class].name,
		       fmslist(class[mp->m_class].birthplace)));
		return 0;
	    }

	where = xyas(sp->sct_x,sp->sct_y,cnum);
	w_p_eff = (mp->m_lcm + (mp->m_hcm * 2));
	points = sp->sct_avail * 100 / w_p_eff;
	cost = (int)((double)mp->m_cost*ship_cost_multiplier);

	if (!god) {
	    if (vec[I_LCM]<mp->m_lcm || vec[I_HCM]<mp->m_hcm) {
		pr(fmt("Not enough materials in %s\n",where));
		return 0;
	    }
	    if (points<20) {
		pr(fmt("Not enough available work in %s to build a %s\n",
		       where, mp->m_name));
		pr(fmt(" (%d available work required)\n",
		       1 + (w_p_eff * 20)/100));
		return 0;
	    }
	    if (cash < cost) {
		pr(fmt("You can't afford to build a %s\n",mp->m_name));
		return 0;
	    }
	    if (!trechk(cnum, 0, NEWSHP))  return 0;
	    sp->sct_avail = (sp->sct_avail * 100 - w_p_eff * 20) / 100;
	    dolcost += cost;
	    cash -= cost;
	}

	/* Find an available slot in the ship database */
	snxtitem_all(&nstr, EF_SHIP);
	while (nxtitem(&nstr, (char *)&ship))
	    if (ship.shp_own == 0)
		break;

	ship.shp_type    = mp - mchr;
	ship.shp_uid     = nstr.cur;
	ship.shp_x       = sp->sct_x;
	ship.shp_y       = sp->sct_y;
	ship.shp_own     = forwhom;
	ship.shp_destx   = sp->sct_x;
	ship.shp_desty   = sp->sct_y;
	ship.shp_effic   = god ? 100 : 20;
	ship.shp_mobil   = god ? 72 : 0;
	ship.shp_autonav = 0;
	ship.shp_depth   = 0;
	ship.shp_odom    = 0;
	ship.shp_nplane  = 0;
	ship.shp_ntank   = 0;
	ship.shp_aboard  = -1;
	ship.shp_fleet   = ' ';
	ship.shp_convoy  = ' ';
	*ship.shp_name   = '\0';
	ship.shp_nv      = 0;
	ship.shp_sell    = 0;
	ship.shp_tech    = tlev;
	ship.shp_air     = mp->m_maxair;

	pr(fmt("%s #%d built ", mp->m_name, nstr.cur));
	if (forwhom != cnum) 
	    pr(fmt("for %s ",cname(forwhom)));
	pr(fmt("in sector %s\n", where));
	
	if (!god) {
	    vec[I_LCM] -= mp->m_lcm;
	    vec[I_HCM] -= mp->m_hcm;
	}
	if (!god && getvar(V_PSTAGE, (char *)sp, EF_SECTOR) == PLG_INFECT)
	    putvar(V_PSTAGE, PLG_EXPOSED, (char *)&ship, EF_SHIP);
	putship(nstr.cur, &ship);

	return 1;
}

static int build_bridge(sp, vec, forwhom)
register struct sctstr *sp;
register int *vec;
natid forwhom;
{
	extern  int buil_bh;
	extern	double buil_bc;
	struct	sctstr sect;
	int	val;
	int	newx, newy;
	int	w_p_eff;
	int	points;

	if (!god) {
	    if (sp->sct_type != SCT_BHEAD) return 0;
	    if (vec[I_HCM] < buil_bh) {
		pr(fmt("%s only has %d unit%s of hcm,\n",
		       xyas(sp->sct_x, sp->sct_y, cnum),
		       vec[I_HCM], vec[I_HCM] > 1 ? "s" : ""));
		pr(fmt("(a bridge span requires %d)\n", buil_bh));
		return 0;
	    }
	    if (cash < buil_bc) {
		pr(fmt("A span costs $%d to build; ", buil_bc));
		pr(fmt("you only have %d.\n", cash));
		return 0;
	    }
	    w_p_eff = buil_bh * 2;
	    points = sp->sct_avail * 100 / w_p_eff;
	    if (points < 20) {
		pr(fmt("Not enough available work in %s to build a bridge\n",
		       xyas(sp->sct_x, sp->sct_y, cnum)));
		pr(fmt(" (%d available work required)\n",
		       1 + (w_p_eff * 20)/100));
		return 0;
	    }
	}
	pr(fmt("Bridge head at %s; ", xyas(sp->sct_x, sp->sct_y, cnum)));
	if ((val = getdir("build span in what direction? ",
		(char *)0, (char *)0, (char *)0)) <= 0)
		return 0;
	newx = sp->sct_x + diroff[val][0];
	newy = sp->sct_y + diroff[val][1];
	if (getsect(newx, newy, &sect) == 0 || sect.sct_type != SCT_WATER) {
		pr(fmt("%s is not a water sector\n",
			xyas(newx, newy, cnum)));
		return 0;
	}
	if (!god) {
	    sp->sct_avail = (sp->sct_avail * 100 - w_p_eff * 20) / 100;
	    dolcost += buil_bc;
	    cash -= buil_bc;
	}
	sect.sct_type = SCT_BSPAN;
	sect.sct_newtype = SCT_BSPAN;
	sect.sct_effic = 20;
	if (god) sect.sct_own = forwhom;
	putsect(&sect);
	pr(fmt("Bridge span built over %s\n",
		xyas(sect.sct_x, sect.sct_y, cnum)));
	setbigmap(sect.sct_x,sect.sct_y,dchr[sect.sct_type].d_mnem);
	writebigmap();
	if (!god) {
	    vec[I_HCM] -= buil_bh;
	}
	return 1;
}

#ifdef NUKES
static int build_nuke(sp, np, vec, forwhom)
register struct sctstr *sp;
register struct nchrstr *np;
register int *vec;
natid forwhom;
{
    int	val;
    struct	nukstr nuke;
    struct	nstr_item nstr;
    int	old;
    int	free;
    int	w_p_eff;
    int	points;
    int	ncost;
    
    if (!god) {
	if (sp->sct_type != SCT_NUKE) return 0;
	if (vec[I_HCM] < np->n_hcm || vec[I_LCM] < np->n_lcm ||
	    vec[I_OIL] < np->n_oil || vec[I_RAD] < np->n_rad) {
	    pr(fmt("Not enough materials for a %s bomb in %s\n",
		   np->n_name, xyas(sp->sct_x, sp->sct_y, cnum)));
	    pr(fmt("(%d hcm, %d lcm, %d oil, & %d rads).\n",
		   np->n_hcm, np->n_lcm, np->n_oil, np->n_rad));
	    return 0;
	}
	ncost = (int)((double)np->n_cost*nuke_cost_multiplier);
	if (cash < ncost) {
	    pr(fmt("You need $%d, you only have %d.\n", ncost, cash));
	    return 0;
	}
	w_p_eff = np->n_rad + np->n_oil + np->n_lcm + np->n_hcm * 2;
	points = sp->sct_avail * 100 / w_p_eff;
	/*
	 ** XXX when nukes turn into units (or whatever), then
	 ** make them start at 20%.  Since they don't have efficiency
	 ** now, we choose 20% as a "big" number.
	 */
	if (points < 20) {
	    pr(fmt("Not enough available work in %s to build a %s;\n",
		   xyas(sp->sct_x, sp->sct_y, cnum), np->n_name));
	    pr(fmt(" (%d available work required)\n",
		   1 + w_p_eff*20/100));
	    return 0;
	}
	if (!trechk(cnum, 0, NEWNUK))
	    return 0;
	sp->sct_avail = (sp->sct_avail * 100 - w_p_eff * 20) / 100;
	dolcost += ncost;
	cash -= ncost;
    }
    
    snxtitem_all(&nstr, EF_NUKE);
    free = -1;
    while (old = nxtitem(&nstr, (char *)&nuke)) {
	if (nuke.nuk_own != cnum) continue;
	if (nuke.nuk_x == sp->sct_x && nuke.nuk_y == sp->sct_y) {
	    val = nstr.cur;
	    break;
	}
	if (nuke.nuk_own == 0 && free < 0)
	    free = nstr.cur;
    }
    if (old == 0) {
	/* not found; use a free slot, or expand file */
	val = (free >= 0) ? free : nstr.cur;
	bzero((char *)&nuke, sizeof(nuke));
    } else {
	if (!getnuke(val, &nuke)) {
	    logerror("Couldn't get nuke #%d\n", val);
	    return 0;
	}
    }
    if (nuke.nuk_own == 0) {
	nuke.nuk_x = sp->sct_x;
	nuke.nuk_y = sp->sct_y;
	nuke.nuk_n = 0;
	nuke.nuk_own = forwhom;
	nuke.nuk_uid = val;
	nuke.nuk_ship = -1;
    }
    nuke.nuk_types[np - nchr]++;
    nuke.nuk_n++;
    putnuke(val, &nuke);
    if (!god) {
	vec[I_HCM] -= np->n_hcm;
	vec[I_LCM] -= np->n_lcm;
	vec[I_OIL] -= np->n_oil;
	vec[I_RAD] -= np->n_rad;
    }
    pr(fmt("%s warhead created ", np->n_name));
    if (cnum != forwhom) pr(fmt("for %s ",cname(forwhom)));
    pr(fmt("in stockpile #%d at %s\n",
	   nuke.nuk_uid, xyas(sp->sct_x, sp->sct_y, cnum)));
    return 1;
}
#endif

#ifdef PLANES
static int build_plane(sp, pp, vec, tlev, forwhom)
register struct sctstr *sp;
register struct plchrstr *pp;
register int *vec;
int tlev;
natid forwhom;
{
	struct	plnstr plane;
	int	cost;
	int	n;
	struct	nstr_item nstr;
	int	points;
	int	w_p_eff;

	if (!god) {
	    if (sp->sct_type != SCT_AIRPT) {
		/* 9/5/90 bf - commented out this obnoxious message */
		/* pr("Planes must be built in airports.\n"); */
		return 0;
	    }
	    if (vec[I_LCM] < pp->pl_lcm || vec[I_HCM] < pp->pl_hcm) {
		pr(fmt("Not enough materials in %s\n",
		       xyas(sp->sct_x, sp->sct_y, cnum)));
		return 0;
	    }
	    w_p_eff = 5 * (pp->pl_lcm + (pp->pl_hcm * 2));
	    points = sp->sct_avail * 100 / w_p_eff;
	    if (points < 10) {
		pr(fmt("Not enough available work in %s to build a %s\n",
		       xyas(sp->sct_x, sp->sct_y, cnum), pp->pl_name));
		pr(fmt(" (%d available work required)\n",
		       1 + 10 * w_p_eff/100));
		return 0;
	    }
	    cost = (int)((double)pp->pl_cost*plane_cost_multiplier);
	    if (cash < cost) {
		pr(fmt("Not enough money left to build a %s\n", pp->pl_name));
		return 0;
	    }
	    if (vec[I_MILIT] < pp->pl_crew) {
		pr(fmt("Not enough military for crew in %s\n",
		       xyas(sp->sct_x, sp->sct_y, cnum)));
		return 0;
	    }
	    if (!trechk(cnum, 0, NEWPLN))
		return 0;
	    sp->sct_avail = (sp->sct_avail * 100 - w_p_eff * 10) / 100;
	    dolcost += cost;
	    cash -= cost;
	}

	snxtitem_all(&nstr, EF_PLANE);
	while (nxtitem(&nstr, (char *)&plane))
		if (plane.pln_own == 0) break;
	plane.pln_x = sp->sct_x;
	plane.pln_y = sp->sct_y;
	plane.pln_own = god ? forwhom : sp->sct_own;
	plane.pln_type = pp - plchr;
	plane.pln_effic = 10;
	plane.pln_mobil = 0;
	n = (int) (pp->pl_range * (0.75 + techfact(tlev - pp->pl_tech, 2.0)));
	if (n > 127) n = 127;
	plane.pln_range = n;
	n = (int) (pp->pl_att * (0.75 + techfact(tlev - pp->pl_tech, 2.0)));
	if (n > 127) n = 127;
	plane.pln_att = n;
	n = (int) (pp->pl_def * (0.75 + techfact(tlev - pp->pl_tech, 2.0)));
	if (n > 127) n = 127;
	plane.pln_def = n;
	plane.pln_wing = ' ';
	plane.pln_tech = tlev;
	plane.pln_ship = -1;
	plane.pln_uid = nstr.cur;
	plane.pln_nukeamt = 0;
	plane.pln_nuketype = 0;
	plane.pln_harden = 0;
	plane.pln_sell = 0;
	plane.pln_flags = 0;
	putplane(nstr.cur, &plane);
	pr(fmt("%s #%d built ", pp->pl_name, nstr.cur));
	if (god && forwhom!=cnum) pr(fmt("for %s ",cname(forwhom)));
	pr(fmt("in sector %s\n",xyas(sp->sct_x, sp->sct_y, cnum)));
	if (!god) {
	    vec[I_LCM] -= pp->pl_lcm;
	    vec[I_HCM] -= pp->pl_hcm;
	    vec[I_MILIT] -= pp->pl_crew;
	}
	return 1;
}
#endif
