#ifndef lint
static char *RCSid = "$Header: coun.c,v 1.1 89/12/14 08:19:33 jay Exp $";
#endif /* not lint */

/*
 * coun.c
 *
 * do a country roster.
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "nat.h"
#include "xy.h"
#include "nsc.h"
#include "file.h"
#include "deity.h"
#include <fcntl.h>

int coun()
{
    extern char *argp[];
    struct nstr_item ni;
    struct natstr nat;
    int	first,enable;

    enable = 0;
    if (god) {
	if (argp[2]) {
	    if (!strncmp(argp[2],"enable",strlen(argp[2]))) enable = 1;
	    else if (!strncmp(argp[2],"disable",strlen(argp[2]))) enable = 2;
	}
    }

    if (!snxtitem(&ni, EF_NATION, argp[1]))
	return RET_SYN;

    ef_reopen(EF_NATION,O_RDONLY,EFF_MEM);

    for (first=1; nxtitem(&ni, (char *)&nat);) {
	if ((nat.nat_stat & STAT_INUSE) == 0) continue;
	if (first) {
	    coun_header();
	    first = 0;
	}
	switch (enable) {
	case 1: nat.nat_stat |= STAT_GOD; break;
	case 2: nat.nat_stat &= ~STAT_GOD; break;
	}
	if (enable) NAT_SET(nat_stat, ni.cur, nat.nat_stat);
	coun_list((natid)ni.cur, &nat);
    }

    if (enable) 
	ef_reopen(EF_NATION,O_RDONLY,EFF_MEM);

    return RET_OK;
}

static
coun_header()
{
	prdate();
	if (god)
	    pr("  #   last access       time\tstatus\t\t country name\n");
	else
	    pr("  #   last access       status     country name\n");
}

static
coun_list(cn, natp)
	natid	cn;
	struct	natstr *natp;
{
	char	*status,*access;
	struct	sctstr sect;
	int secret;

	secret = 1;
	switch (natp->nat_stat & (STAT_NORM|STAT_GOD|STAT_NEW|STAT_SANCT)) {
	case 0:
		status = "Visitor";
		break;
	case STAT_NEW:
		status = "New";
		break;
	case STAT_SANCT:
		status = "Sanctuary";
		break;
	case (STAT_NORM|STAT_SANCT):
		getsect(natp->nat_xcap, natp->nat_ycap, &sect);
		if (sect.sct_own != cn ||
		    sect.sct_type != SCT_CAPIT)
			status = "In flux";
		else if (natp->nat_money < 0)
			status = "Broke";
		else
			status = "Active";
		secret = 0;
		break;
	case (STAT_GOD|STAT_NORM):
	case (STAT_GOD|STAT_NORM|STAT_SANCT):
		status = "DEITY";
		break;
	default:
		status = "Buggy";
		break;
	}

	access = natp->nat_login ? " Now logged on" : ctime(&natp->nat_date);

	if (god) pr(fmt("%3d  %-16.16s   [%d]\t%-9.9s\t %s\n",
			cn, access, natp->nat_btu, status, natp->nat_cnam));
	else if (!secret) pr(fmt("%3d  %-16.16s  %-9.9s  %s\n",
				 cn, access, status, natp->nat_cnam));
    }
