#ifndef lint
static char *RCSid = "$Header: crat.c,v 1.1 89/12/14 08:20:31 jay Exp $";
#endif

/*
 * crat.c
 *
 * Crate/uncrate aircraft.
 *
 * Bill Frolik, 1991
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "plane.h"
#include "nsc.h"
#include "nuke.h"
#include "file.h"
#include "nat.h"
#include "sect.h"
#include "deity.h"

extern double crate_cost;

crate()		{ return crat(1); }
uncrate() 	{ return crat(0); }

crat(disassemble)
int disassemble;
{
    extern char *argp[];
    int cash,cost;
    int wpeff,points,wf;
    struct nstr_item np;
    struct natstr *natp;
    struct plnstr plane;
    struct plchrstr *pp;
    struct sctstr sect;
    
    if (!snxtitem(&np, EF_PLANE, argp[1])) return RET_SYN;

    natp = getnatp(cnum);
    cash = natp->nat_money;

    while (nxtitem(&np, (char *)&plane)) {
	if ((!god && !owner) || plane.pln_own == 0) continue;
	if (!getsect(plane.pln_x,plane.pln_y,&sect)) continue;

	if (plane.pln_ship >= 0) {
	    pr(fmt("%s #%d can't be %scrated during transport.\n",
		   plchr[plane.pln_type].pl_name,np.cur));
	    continue;
	}

#ifdef TRADECENTERS
	if (sect.sct_type != SCT_AIRPT && sect.sct_type != SCT_TRADE && !god) {
	    pr(fmt("%s #%d isn't at airport or trade center.\n",
		   plchr[plane.pln_type].pl_name,np.cur));
	    continue;
	}
#else
	if (sect.sct_type != SCT_AIRPT && !god) {
	    pr(fmt("%s #%d isn't at airport.\n",
		   plchr[plane.pln_type].pl_name,np.cur));
	    continue;
	}
#endif

	if (sect.sct_own != cnum) {
	    if (getrel(sect.sct_own,cnum) != ALLIED) {
		pr(fmt("Nonallied workers in %s refuse to %scrate %s #%d.\n",
		       xyas(plane.pln_x,plane.pln_y,cnum),
		       disassemble ? "" : "un",
		       plchr[plane.pln_type].pl_name,np.cur));
		continue;
	    }
	}

	if (sect.sct_effic < 60) {
	    pr(fmt("Sector %s not up to 60%% efficiency.\n",
		   xyas(plane.pln_x,plane.pln_y,cnum)));
	    continue;
	}

	pp = &plchr[plane.pln_type];
	wpeff = (pp->pl_lcm + pp->pl_hcm*2)*100 / (double)sect.sct_effic;
	points = sect.sct_avail*100/wpeff;
	wf = 10*wpeff/100 + 1;
	cost = (int)((double)pp->pl_cost*crate_cost + 0.5);

	if (points < 10) {
	    pr(fmt("Need %d avail workers in %s to %scrate %s #%d.\n",
		   wf, xyas(plane.pln_x,plane.pln_y,cnum),
		   disassemble ? "" : "un",
		   plchr[plane.pln_type].pl_name,np.cur));
	    continue;
	}

	if (cost > cash) {
	    pr(fmt("You don't have the $%d needed to %scrate %s #%d.\n",
		   cost,disassemble ? "un" : "",
		   plchr[plane.pln_type].pl_name,np.cur));
	    continue;
	}

	pr(fmt("%s #%d in %s ",
	       plchr[plane.pln_type].pl_name,np.cur,
	       xyas(plane.pln_x,plane.pln_y,cnum)));

	if (disassemble) { /* take plane apart */

	    if (plane.pln_flags & PLN_BOXED) {
		pr("is already crated\n");
		continue;
	    }
	    plane.pln_flags |= PLN_BOXED;
	    pr("disassembled and put into crates\n");

	} else { /* put plane back together */

	    if (!(plane.pln_flags & PLN_BOXED)) {
		pr("already assembled\n");
		continue;
	    }
	    plane.pln_flags &= ~PLN_BOXED;
	    pr("crates opened and aircraft reassembled\n");

	}

	plane.pln_effic = 10;
	plane.pln_mobil = 0;
	sect.sct_avail -= wf;
	if (sect.sct_avail < 0) sect.sct_avail = 0;
	dolcost += cost;
	cash -= cost;
	putplane(np.cur,&plane);
	putsect(&sect);
    }
    return RET_OK;
}
