#ifndef lint
static char *RCSid = "$Header: scra.c,v 1.1 89/12/14 08:20:46 jay Exp $";
#endif /* not lint */

/*
 * dest.c
 *
 * Destroy ships or planes by holy vaporization
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"
#include "nat.h"
#include "nsc.h"
#include "deity.h"
#include "file.h"

union item_u {
    struct shpstr ship;
    struct plnstr plane;
};

dest()
{
    extern char *argp[];
    struct nstr_item ni;
    union item_u item;
    int	type,transport;
    struct sctstr sect;
    struct mchrstr *mp;
    struct plchrstr *pp;
    char *p;
    int	i;
    
    if (!(p = getstarg(argp[1], "Vehicle class? "))) return RET_SYN;
    type = ef_byname(p);
    if (type == EF_SECTOR) type = EF_SHIP;
    if (type != EF_SHIP && type != EF_PLANE) {
	pr("Ship, plane, tank, balloon, or train only!\n");
	return RET_SYN;
    }
    
    if (!snxtitem(&ni, type, argp[2]))
	return RET_SYN;
    
    while (nxtitem(&ni, (char *)&item)) {
	if (!(god || owner)) continue;
	if (type == EF_SHIP) getsect(item.ship.shp_x, item.ship.shp_y, &sect);
	else getsect(item.plane.pln_x, item.plane.pln_y, &sect);
	if (type == EF_SHIP) {
	    transport = item.ship.shp_aboard;
	    item.ship.shp_own = 0;
	    item.ship.shp_effic = 0;
	    item.ship.shp_aboard = -1;
	    putship(item.ship.shp_uid, (char *)&item.ship);
	} else {
	    transport = item.plane.pln_ship;
	    item.plane.pln_own = 0;
	    item.plane.pln_effic = 0;
	    item.plane.pln_ship = -1;
	    putplane(item.plane.pln_uid, (char *)&item.plane);
	}
	if (transport >= 0) {
	    getship(transport,(char *)&item.ship);
	    if (type == EF_SHIP) {
		if (--item.ship.shp_ntank < 0)
		    item.ship.shp_ntank = 0;
	    } else {
		if (--item.ship.shp_nplane < 0)
		    item.ship.shp_nplane = 0;
	    }
	    putship(transport,(char *)&item.ship);
	}
    }
    return RET_OK;
}
