#ifndef lint
static char *RCSid = "$Header: map.c,v 1.1 89/12/14 08:20:08 jay Exp $";
#endif /* not lint */

/*
** elev.c
**
** elevation map
*/

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "xy.h"
#include "nsc.h"
#include "file.h"
#include "deity.h"
#include "nat.h"
#include "map.h"

elev()
{
    extern int aborted;
    extern char *argp[];
    register char *ptr;
    struct nstr_sect ns;
    struct natstr *np;
    struct sctstr sect;
    struct range range;
    int	i,list;
    u_char bitmap[WORLD_X*WORLD_Y/8];
    char wmap[WORLD_Y][MAPWIDTH(1)];
    coord y;
    char *p;
    struct nstr_item ni;

    if (!snxtsct(&ns, argp[1]))	return RET_FAIL;
    list = (argp[2] && *argp[2]=='l') ? 1 : 0;
    np = getnatp(cnum);
    bzero((char *)bitmap, sizeof(bitmap));
    bitinit(&ns, bitmap);
	
    /* zap any conditionals */
    ns.ncond = 0;
    xyrelrange(np, &ns.range, &range);
    if (!list) border(&range, "     ", "");
    blankfill((char *)wmap, &ns.range, 1);
    while (nxtsct(&ns, &sect) && !aborted) {
	if (!god && !getbit(ns.x, ns.y, bitmap)) continue;
	ptr = &wmap[ns.dy][ns.dx];
	if (sect.sct_type==SCT_WATER) *ptr = '.';
	else {
#ifdef ELEVATIONS
	    i = sect.sct_elev/10;
	    if (i<0) *ptr = '*';
	    else if (i<100) *ptr = (i % 10) + '0';
	    else *ptr = 'A' + i;
#else
	    *ptr = (sect.sct_type==SCT_MOUNT) ? '1' : '0';
#endif
	    if (list) {
		if (list++ == 1) 
		    pr("  sect    type  elev\n");
#ifdef ELEVATIONS
		pr(fmt("%s   %c    %d\n",
		       xyfmt("%4d,%-4d",ns.x,ns.y,cnum),
		       dchr[sect.sct_type].d_mnem,
		       sect.sct_elev));
#else
		pr(fmt("%s   %c    %d\n",
		       xyfmt("%4d,%-4d",ns.x,ns.y,cnum),
		       dchr[sect.sct_type].d_mnem,
		       *ptr=='1' ? 1 : 0));
#endif
	    }
	}
    }
    if (!list) {
	if (aborted) return RET_OK;
	for (y=ns.range.ly, i=0; i < ns.range.height; y++, i++) {
	    int yval;
	    yval = yrel(np, y);
	    pr(fmt("%4d %s %-4d\n", yval, wmap[i], yval));
	    if (y >= WORLD_Y)
		y -= WORLD_Y;
	}
	border(&range, "     ", "");
    }
    return RET_OK;
}
