#ifndef lint
static char *RCSid = "$Header: hard.c,v 1.1 89/12/14 08:19:57 jay Exp $";
#endif /* not lint */

/*
 * hard.c
 *
 * increases the silo protection of a given missile.
 *
 * Dave Pare, 1986
 *
 * 4/18/91 bf@hp - modified to harden sectors (build bunkers)
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "item.h"
#include "plane.h"
#include "nuke.h"
#include "ship.h"
#include "xy.h"
#include "nsc.h"
#include "nat.h"
#include "file.h"

extern double bunker_cost;

/*
 * harden <PLANE> <LEVEL>
 * harden <SECTOR> <LEVEL>
 */
hard()
{
	extern	char *argp[];
	struct	plchrstr *pcp;
	struct	plnstr pln;
	int	level;
	char	*p;
	int	hcm;
	int	n,failure;
	int	type;
	int	item[I_MAX+1];
	struct	nstr_item ni;
	struct	sctstr sect;
	double	cost;

#ifdef BUNKERS
	p = getstarg(argp[1],"Harden (plane #(s) or sector(s)) : ");
	if (p == 0) return RET_SYN;
	if (sarg_type(p) == NS_AREA) {
	    if (!snxtsct(&ni, p)) return RET_SYN;
	    p = getstarg(argp[2], "Increase bunker size by? ");
	    if (!p || !*p) return RET_SYN;
	    level = atoi(p);
	    if (level<0) return RET_SYN;
	    pr("   x,y     des  hcm  avail  bunker size\n");
	    cost = 0.0;
	    while (nxtsct(&ni, &sect)) {
		if (!owner) continue;
		getvec(VT_ITEM,item,(char *)&sect,EF_SECTOR);
		failure = 0;
		n = (sect.sct_harden+level > 255) ? 
		    255-sect.sct_harden : level; /* actual increase */
		if (n > 0) {
		    if (sect.sct_avail < n) failure = 1;
		    if (item[I_HCM] < n) failure = 2;
		    if (!failure) {
			item[I_HCM] -= n;
			sect.sct_avail -= n;
			sect.sct_harden += n;
			cost += ((double)n * bunker_cost);
			putvec(VT_ITEM,item,(char *)&sect,EF_SECTOR);
			putsect(&sect);
		    }
		}
                pr(xyfmt("%4d,%-4d   ",sect.sct_x, sect.sct_y, cnum));
		pr(fmt("%c%6d%7d%9d       ",
		       dchr[sect.sct_newtype].d_mnem,
		       item[I_HCM],
		       sect.sct_avail,
		       sect.sct_harden));
		switch (failure) {
		case 1: 
		    pr(fmt("low workforce (need %d avail)",n));
		    break;
		case 2: 
		    pr(fmt("low resources (need %d hcms)",n)); 
		    break;
		}
		pr("\n");
	    }
	    dolcost += (int)cost;
	    return RET_OK;
	}
#else
	p = getstarg(argp[1],"Harden plane #(s) : ");
	if (p == 0) return RET_SYN;
#endif

	if (!snxtitem(&ni, EF_PLANE, argp[1]))
		return RET_SYN;
	if ((p = getstarg(argp[2], "Increase by? ")) == 0 || *p == 0)
		return RET_SYN;
	level = atoi(p);
	if (level < 0)
		return RET_SYN;
	while (nxtitem(&ni, (char *)&pln)) {
		if (!owner)
			continue;
		pcp = &plchr[pln.pln_type];
		if ((pcp->pl_flags & P_M) == 0) {
			pr(fmt("%s #%d isn't a missile!\n", pcp->pl_name,
				pln.pln_uid));
			continue;
		}
		if (pln.pln_ship >= 0)	/* can't harden ssbns ... */
			continue;
		n = level;
		if (level + pln.pln_harden > 127)
			n = 127 - pln.pln_harden;
		if (n <= 0) {
			pr(fmt("%s #%d is already completely hardened!\n",
				pcp->pl_name, pln.pln_uid));
			continue;
		}
		if (!getsect(pln.pln_x, pln.pln_y, &sect))
			continue;
		if (sect.sct_own != cnum) {
			pr(fmt("%s #%d: you don't own %s!\n", pcp->pl_name,
				pln.pln_uid,
				xyas(pln.pln_x, pln.pln_y, cnum)));
			continue;
		}
		hcm = getvar(V_HCM, (char *)&sect, EF_SECTOR);
		if (hcm == 0) {
			pr(fmt("No hcm in %s\n",
				xyas(pln.pln_x, pln.pln_y, cnum)));
			continue;
		}
		if (hcm <= n)
			n = hcm;
		pln.pln_harden += n;
		dolcost += (5.0 * n);
		putplane(pln.pln_uid, &pln);
		putvar(V_HCM, hcm - n, (char *)&sect, EF_SECTOR);
		putsect(&sect);
		pr(fmt("%s #%d hardened to %d\n", plchr[pln.pln_type].pl_name,
			pln.pln_uid, pln.pln_harden));
	}
	return RET_OK;
}
