/*
**  name.c
**
**  Name a ship, spy, or vehicle.
**
**  8/19/91 Bill Frolik
*/

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "spy.h"
#include "nat.h"
#include "nsc.h"
#include "deity.h"
#include "file.h"
#include "loc.h"

extern char *argp[];

pnam()
{
    char *s,namebuf[128];
    s = getstarg(argp[1],"Pathname (create, list, delete) ? ");
    if (!s || !*s) return RET_SYN;
    switch (*s) {
    case 'l':
	return shownamedpaths(cnum);
    case 'd':
	s = getstarg(argp[2],"Delete which pathname ? ");
	if (!s || !*s) return RET_SYN;
	return delnamedpath(s,cnum);
    case 'c':
	s = getstarg(argp[2],"Enter new pathname : ");
	if (!s || !*s) return RET_SYN;
	strcpy(namebuf,s);
	s = getstarg(argp[3],"Enter path : ");
	if (!s || !*s) return RET_SYN;
	return setnamedpath(namebuf,s,cnum);
    }
    return RET_SYN;
}

/* ________________________________________________________________
**|                                                                |
**| name - christen a ship, spy, or vehicle			   |
**|________________________________________________________________|
*/

name()
{
    char *s;
    int vc;
    s = getstarg(argp[1],"Name what (ship, tank, balloon, train, spy) ? ");
    if (!s || !*s) return RET_SYN;
    for (vc=0; vc<NUM_CLASSES; vc++)
	if (!strncmp(s,class[vc].name,strlen(s))) break;
    return ((vc >= NUM_CLASSES)
	    ? ((strncmp(s,"spy",strlen(s)) 
		? RET_SYN 
		: christenspy()))
	    : christenship(vc));
}

christenspy()
{
    int nspies;
    struct nstr_item ni;
    struct spystr spy;
    if (!snxtitem(&ni, EF_SPY, argp[2])) return RET_SYN;
    while (nxtitem(&ni, (char *)&spy)) {
	if (!spy.spy_own || (!god && spy.spy_own!=cnum)) continue;
	if (spy.spy_type < 0 || spy.spy_type > spy_maxno) {
	    logerror(fmt("bad spy type %d (#%d)\n", spy.spy_type, ni.cur));
	    continue;
	}
	if (getnewname(spy.spy_name, argp[3],
		       fmt("%s; new name : ",spyas(&spy,0))))
	    putspy(spy.spy_uid,&spy);
    }
    return RET_OK;
}

christenship(vc)
int vc;
{
    int nships;
    struct nstr_item ni;
    struct shpstr ship;
    if (!snxtitem(&ni, EF_SHIP, argp[2])) return RET_SYN;
    while (nxtitem(&ni, (char *)&ship)) {
	if (!ship.shp_own || (!god && ship.shp_own!=cnum)) continue;
	if (ship.shp_type < 0 || ship.shp_type > shp_maxno) {
	    logerror(fmt("bad ship type %d (#%d)\n", ship.shp_type, ni.cur));
	    continue;
	}
	if (mchr[ship.shp_type].m_class != vc) continue;
	if (getnewname(ship.shp_name, argp[3],
		       fmt("%s; new name : ",shipas(&ship,0))))
	    putship(ship.shp_uid,&ship);
    }
    return RET_OK;
}

getnewname(dst,src,prompt)
char *dst,*src,*prompt;
{
    char *s;
    s = getstarg(src,prompt);
    if (!s || !*s) return 0;
    if (*s<=' ' || *s=='~') s = "";
    if (strlen(s)>(NS_NSIZE-1)) s[NS_NSIZE-1] = '\0';
    strcpy(dst,s);
    return 1;
}
