#ifndef lint
static char *RCSid = "$Header: plan.c,v 1.1 89/12/14 08:20:31 jay Exp $";
#endif

/*
 * plan.c
 *
 * Do a "plane report" (like ships report)
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "plane.h"
#include "nsc.h"
#include "nuke.h"
#include "file.h"
#include "nat.h"
#include "deity.h"

plan()
{
    extern char *argp[];
    int nplanes;
    struct nstr_item np;
    struct plnstr plane;
    if (!snxtitem(&np, EF_PLANE, argp[1])) return RET_SYN;
    for (nplanes=0; nxtitem(&np, (char *)&plane);) {
	if ((!god && plane.pln_own!=cnum) || (plane.pln_own==0)) continue;
	showplane(&plane, (nplanes++ == 0), 0);
    }
    return summarize(argp[1],nplanes,"plane");
}

showplane(plane,header,plusorminus)
struct plnstr *plane;
int header,plusorminus;
{
    if (header) {
	prest(plusorminus);
	if (god || plusorminus) pr("own ");
	pr("   #    type           x,y    ");
	pr("w  eff  mu att def tech ran hard ship nuke\n");
    }
    if (god || plusorminus) pr(fmt("%3d ", plane->pln_own));
    pr(fmt("%4d %-14.14s %s %c ",
	   plane->pln_uid, plchr[plane->pln_type].pl_name,
	   xyfmt("%4d,%-4d", plane->pln_x, plane->pln_y, cnum),
	   plane->pln_wing));
    if (plane->pln_flags & PLN_BOXED)
	pr("-crated-");
    else
	pr(fmt("%3d%% %3d",
	       limestimate(plane->pln_effic,plusorminus,0,100),
	       estimate(plane->pln_mobil,plusorminus)));
    pr(fmt(" %3d %3d  %3d %3d  %3d",
	   estimate(plane->pln_att,plusorminus),
	   estimate(plane->pln_def,plusorminus),
	   estimate(plane->pln_tech,plusorminus),
	   estimate(plane->pln_range,plusorminus),
	   estimate(plane->pln_harden,plusorminus)));
    if (plane->pln_ship >= 0)
	pr(fmt("%5d", plane->pln_ship));
    else
	pr("     ");
    if (plane->pln_nukeamt > 0)
	pr(fmt(" %1d %9.9s\n",
	       plane->pln_nukeamt,
	       nchr[plane->pln_nuketype].n_name));
    else
	pr("\n");
}
