#ifndef lint
static char *RCSid = "$Header: rada.c,v 1.1 89/12/14 08:20:34 jay Exp $";
#endif

/*
 * rada.c
 *
 * do radar from ship or sector
 *
 * from PSL Empire, 1985
 * XXX should give better error messages when radaring from bad ship/sect.
 */

#include <ctype.h>
#include "misc.h"
#include "xy.h"
#include "var.h"
#include "ship.h"
#include "sect.h"
#include "nsc.h"
#include "nat.h"
#include "file.h"

rada()
{
    extern	char *argp[];
    char	*cp;
    int	type;
    double	tf;
    double	tech;
    struct	nstr_item ni;
    struct	nstr_sect ns;
    struct	shpstr ship;
    struct	sctstr sect;
    int	vec[I_MAX+1];
    
    cp = getstarg(argp[1], "Radar from (ship/vehicle # or sector(s)) : ");
    if (cp == 0) return RET_SYN;
    type = sarg_type(cp);
    if (type == NS_AREA) {
	if (!snxtsct(&ns, cp)) return RET_SYN;
	tech = tfact(cnum, 8.0);
	while (nxtsct(&ns, &sect)) {
	    if (sect.sct_type != SCT_RADAR) continue;
	    if (!owner) continue;
	    radmap(sect.sct_x, sect.sct_y, (int)sect.sct_effic,
		   (int) (tech * 2), 0.0);
	}
    } else if (type == NS_LIST || type == NS_GROUP) {
	/* assumes a NS_LIST return is a shipno */
	if (!snxtitem(&ni, EF_SHIP, cp)) {
	    pr("Specify at least one ship\n");
	    return RET_SYN;
	}
	while (nxtitem(&ni, (char *)&ship)) {
	    if (!owner) continue;
	    getvec(VT_ITEM, vec, (char *)&ship, EF_SHIP);
	    if (vec[I_MILIT]+vec[I_CIVIL] == 0) continue; /* no crew */
	    pr(fmt("%s at ", shipas(&ship,0)));
	    if (!isballoon(&ship) && ship.shp_depth>0) {
		tf = 0.0;
		tech = techfact(0,1.0);
	    } else {
		tf = (mchr[ship.shp_type].m_flags & M_SONAR)
		    ? techfact(ship.shp_tech, 1.0) 
		    : 0.0;
		/* viewing range increases with altitude */
		tech = techfact(ship.shp_tech,
  		    (double) mchr[ship.shp_type].m_vrnge *
	 	    ((double)ship.shp_depth/3.0 + 1.0));
	    }
	    radmap(ship.shp_x, ship.shp_y, ship.shp_effic,
		   (int) tech, tf);
	}
    } else {
	pr("Must use a ship or sector specifier\n");
	return RET_SYN;
    }
    return RET_OK;
}
