#ifndef lint
static char *RCSid = "$Header: scra.c,v 1.1 89/12/14 08:20:46 jay Exp $";
#endif /* not lint */

/*
**  scut.c
**
**  Scuttle ships
**
**  4/24/91 Bill Frolik
*/

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"
#include "nat.h"
#include "nsc.h"
#include "loc.h"
#include "deity.h"
#include "file.h"

union item_u {
	struct shpstr ship;
	struct plnstr plane;
};


scut()
{
    extern char *argp[];
    struct nstr_item ni;
    struct natstr *natp;
    struct shpstr ship;
    struct plnstr plane;
    union item_u q;
    int	inspace,type,item[I_MAX+1];
    struct sctstr sect;
    struct mchrstr *mp;
    struct plchrstr *pp;
    int	crew,crewmil,crewcivs,crewuws;
    int i,locals,localmil,localcivs;
    int reserves,civslost,uwslost,millost,saved;
    char *p;
    
    if (!(p = getstarg(argp[1], "Ship or plane? "))) 
	return RET_SYN;
    type = ef_byname(p);
    if (type == EF_SECTOR) type = EF_SHIP;
    if (type != EF_SHIP && type != EF_PLANE) {
	pr("Ships or planes only!\n");
	return RET_SYN;
    }
    
    if (!snxtitem(&ni, type, argp[2]))
	return RET_SYN;
    
    natp = getnatp(cnum);
    millost = civslost = uwslost = reserves = 0;

    while (nxtitem(&ni, (char *)&q)) {
	inspace = 0;
	if (!owner) continue;

	if (type == EF_SHIP) {

	    if (!getsect(q.ship.shp_x, q.ship.shp_y, &sect)) continue;
	    mp = &mchr[q.ship.shp_type];

	    getvec(VT_ITEM, item, (char *)&q.ship, EF_SHIP);
	    crewmil = item[I_MILIT];
	    crewcivs = item[I_CIVIL];
	    crewuws = item[I_UW];
	    crew = crewmil+crewcivs;

	    getvec(VT_ITEM, item, (char *)&sect, EF_SECTOR);
	    localmil = item[I_MILIT];
	    localcivs = item[I_CIVIL];
	    locals = localmil+localcivs;

	    if (!god && sect.sct_own!=cnum && !crew) {
		pr(fmt("%s can't be scuttled without a crew.\n",
		       shipas(&q.ship,0)));
		continue;
	    }
	    if (!god && !crew && !locals) {
		pr(fmt("%s can't be scuttled in its current location.\n",
		       shipas(&q.ship,0)));
		continue;
	    }

	    q.ship.shp_own = 0;
	    putship(q.ship.shp_uid, (char *)&q.ship);

	} else { /* type == EF_PLANE */

	    if (!getsect(q.plane.pln_x, q.plane.pln_y, &sect)) continue;
	    pp = &plchr[q.plane.pln_type];
	    inspace = (pp->pl_flags & P_O);

	    getvec(VT_ITEM, item, (char *)&sect, EF_SECTOR);
	    crewcivs = crewuws = 0;
	    crew = crewmil = pp->pl_crew;
	    q.plane.pln_own = 0;
	    putplane(q.plane.pln_uid, (char *)&q.plane);

	}

	if (sect.sct_type != SCT_WATER) {
	    item[I_CIVIL] += crewcivs;
	    item[I_UW] += crewuws;
	} else {
	    civslost += crewcivs;
	    uwslost += crewuws;
	}
	if (sect.sct_own==cnum) { /* scuttled on home turf */
	    item[I_MILIT] += crewmil;
	} else {
	    if (sect.sct_own) {
		millost = crewmil;
		wu(0,sect.sct_own,
		   fmt("%s scuttled %s #%d in your sector %s\n",
		       cname(cnum),
		       (type==EF_SHIP) ? mp->m_name : pp->pl_name,
		       (type==EF_SHIP) ? q.ship.shp_uid : q.plane.pln_uid,
		       xyas(sect.sct_x,sect.sct_y,sect.sct_own)));
	    } else 
		millost = crewmil * roll(100) / 100;
	    saved = crewmil-millost;
	    reserves += saved;
	}

	putvec(VT_ITEM, item, (char *)&sect, EF_SECTOR);
	putsect(&sect);
    }

    i = 0;
    if (civslost+uwslost+millost) {
	if (civslost>5 || uwslost>40) pr("You butcher!  ");
	pr("You just sacrificed ");
	if (civslost) { pr(fmt("%d civ",civslost)); i++; }
	if (uwslost)  { pr(fmt("%s%d uw", i?", ":"", uwslost)); i++; }
	if (millost)  { pr(fmt("%s%d mil", i?", ":"", millost)); i++; }
	pr(".\n");
    }
    if (reserves) {
	NAT_DELTA(nat_reserve, cnum, reserves);
	pr(fmt("%d mil rescued.\n", reserves));
	pr(fmt("Military reserve stands at %d.\n", natp->nat_reserve));
    }

    return RET_OK;
}
