#ifndef lint
static char *RCSid = "$Header: show.c,v 1.1 89/12/14 08:20:56 jay Exp $";
#endif

/*
 * show - give info on empire internal data structures - e.g.
 * 	planes, boats, nukes etc.
 *
 * Julian Onions, 1988
 */

#include "misc.h"
#include "nat.h"
#include "file.h"
#include "deity.h"
#include "ship.h"
#include "nuke.h"

extern int show_nuke_build();
extern int show_nuke_capab();
extern int show_plane_build();
extern int show_plane_capab();
extern int show_spy_train();
extern int show_spy_capab();
extern int show_vehicle_build();
extern int show_vehicle_capab();
extern int show_blast_profile();
extern int show_balloon_volume();
extern int show_sub_volume();

show()
{
    extern char *argp[];
    char *p,*p2,linebuf[80];
    struct natstr *natp;
    int	tlev,vc,i;

    natp = getnatp (cnum);
    tlev = (int) (1.5 * natp->nat_level[NAT_TLEV]);
    if (god) tlev = 99999;

    strcpy(linebuf,"Show what (bridge, ship");
#ifdef TANKS
    strcat(linebuf,", tank");
#endif
#ifdef BALLOONS
    strcat(linebuf,", balloon");
#endif	
#ifdef TRAINS
    strcat(linebuf,", train");
#endif	
#ifdef PLANES
    strcat(linebuf,", plane");
#endif
#ifdef NUKES
    strcat(linebuf,", nuke, blast");
#endif
#ifdef SPIES
    strcat(linebuf,", spy");
#endif
    strcat(linebuf,")? ");
    p = getstarg(argp[1],linebuf);

#ifdef NUKES
    if (patmat(p,"bl*",1)) {
	p = getstarg(argp[2],"Nuke type? ");
	if (!p || !*p) return RET_SYN;
	for (i=vc=0;i<N_MAXNUKE;i++) {
	    if (nchr[i].n_tech < tlev) {
		if (!strncmp(p,nchr[i].n_name,strlen(p))) {
		    show_blast_profile(&nchr[i]);
		    vc++;
		}
	    }
	}
	if (vc==0) {
	    pr("Blast profiles are available for:\n");
	    for (i=0;i<N_MAXNUKE;i++)
		pr(fmt("  %s\n",nchr[i].n_name));
	    return RET_SYN;
	}
	return RET_OK;
    }
#endif

#ifdef BALLOONS	

    if (patmat(p,"br*",1)) {
	show_bridge(99999);
	return RET_OK;
    }
    if (patmat(p,"b*",1))
	p2 = "Build, capability, or volume data (b, c, or v)? ";
    else
	p2 = "Build or capability data (b or c)? ";

#else

    if (patmat(p,"b*",1)) {
	show_bridge(99999); 
	return RET_OK;
    }
    p2 = "Build or capability data (b or c)? ";

#endif

#ifdef SPIES
    if (patmat(p,"sp*",1))
	switch (*(p=getstarg(argp[2],p2))) {
	case 'B': case 'b': show_spy_build(tlev); return RET_OK;
	case 'C': case 'c': show_spy_capab(tlev); return RET_OK;
	default: return RET_SYN;
	}
#endif
    
#ifdef PLANES
    if (patmat(p,"p*",1))
	switch (*(p=getstarg(argp[2],p2))) {
	case 'B': case 'b': show_plane_build(tlev); return RET_OK;
	case 'C': case 'c': show_plane_capab(tlev); return RET_OK;
	default: return RET_SYN;
	}
#endif
    
#ifdef NUKES
    if (patmat(p,"n*",1))
	switch (*(p=getstarg(argp[2],p2))) {
	case 'B': case 'b': show_nuke_build(tlev); return RET_OK;
	case 'C': case 'c': show_nuke_capab(tlev); return RET_OK;
	default: return RET_SYN;
	}
#endif
    
    if (patmat(p,"b*",1))       vc = CLASS_BALLOON; 
    else if (patmat(p,"s*",1))  vc = CLASS_SHIP; 
    else if (patmat(p,"ta*",1)) vc = CLASS_TANK; 
    else if (patmat(p,"tr*",1)) vc = CLASS_TRAIN; 
    else return RET_SYN;
    
    switch (*(p=getstarg(argp[2],p2))) {
    case 'B': case 'b': show_vehicle_build(tlev,vc); return RET_OK;
    case 'C': case 'c': show_vehicle_capab(tlev,vc); return RET_OK;
    case 'V': case 'v': 
	if (vc==CLASS_SHIP) {
	    show_sub_volume(tlev); return RET_OK;
	}
	if (vc==CLASS_BALLOON) {
	    show_balloon_volume(tlev); return RET_OK;
	}
    default: return RET_SYN;
    }
}
