#ifndef lint
static char *RCSid = "$Header: vers.c,v 1.1 89/12/14 08:21:13 jay Exp $";
#endif /* not lint */

/*
 * vers.c
 *
 * empire version (probably out of date by now!)
 *
 * from PSL Empire, 1985
 */

#include <time.h>
#include "gamesdef.h"
#include "misc.h"
#include "deity.h"
#include "nat.h"
#include "version.h"
#include "lotto.h"

vers()
{
    extern	int sect_mob_max;
    extern	int sect_mob_scale;
    extern	int ship_mob_max;
    extern	int ship_mob_scale;
    extern	int plane_mob_max;
    extern	int plane_mob_scale;
    extern	int spy_mob_max;
    extern	int spy_mob_scale;
    extern	int civexplore;
    extern	int milexplore;
    extern	double civexploremob;
    extern	double milexploremob;
    extern	double explorecost;	
    extern	double bunker_cost;
    extern	double bunker_strength;
    extern	double killcost;
    extern	double capturecost;
    extern	double searchcost;
    extern	double retire_pay;
    extern	short spy_retire;
    extern	u_char wastetime;
    extern	double min_btus_per_etu;
    extern	int s_p_etu;
    extern	int etu_per_update;
    extern	int adj_update;
    extern	int m_m_p_d;
    extern	int players_at_00;
    extern	float btu_build_rate;
    extern	double fgrate, fcrate;
    extern	double eatrate, babyeat;
    extern	double obrate, uwbrate;
    extern	double bankint;
    extern	double hap_cons, edu_cons;
    extern	double money_civ, money_uw, money_mil, money_res;
    extern	float hap_avg, edu_avg, ally_factor;
    extern	float level_age_rate;
    extern	float easy_tech, hard_tech, tech_log_base;
    time_t	now;
    time_t	upd_time;
    time_t	next_update;
    int	secs_per_update;
    int	i,delta;

    (void) time(&now);
    upd_time = now + adj_update;
    secs_per_update = etu_per_update * s_p_etu;
    delta = secs_per_update - (upd_time % secs_per_update);
    next_update = now + delta;

	pr(fmt("BSD Empire %d.%d patch level %d (HP Corvallis Version)\n\n",
		EMP_VERS_MAJOR, EMP_VERS_MINOR, EMP_VERS_PATCH));
	pr("The following parameters have been set for this game:\n");
	pr(fmt("World size is %d by %d.\n", WORLD_X, WORLD_Y));
	pr(fmt("There can be up to %d countries.\n", MAXNOC));
	pr(fmt("By default, countries use %s coordinate system.\n",
		(players_at_00) ? "the deity's" : "their own"));
	pr("\n");
	pr(fmt("An Empire time unit is %d second%s long.\n",
		s_p_etu, s_p_etu != 1 ? "s" : ""));
	pr(fmt("The next update is at %19.19s.\n",ctime(&next_update)));
	pr(fmt("The current time is %19.19s.\n",ctime(&now)));
	pr(fmt("An update consists of %d empire time units.\n",
		etu_per_update));
	pr(fmt("Each country is allowed to be logged in %d minutes a day.\n",
		m_m_p_d));
	pr(fmt("It takes %.2f civilians to produce a BTU in one time unit.\n",
		(1.0/(btu_build_rate*100.0))));
        pr(fmt("You are guaranteed to gain at least %.2f BTU per inactive time unit.\n",
	       min_btus_per_etu));
	pr("\n");

	pr(fmt("A non-aggi, 100 fertility sector can grow %.2f food per etu.\n",
		100.0 * fgrate));
	pr(fmt("1000 civilians will harvest %.1f food per etu.\n",
			1000.0*fcrate));
	pr(fmt("1000 civilians will give birth to %.1f babies per etu.\n", 
			1000.0*obrate));
	pr(fmt("1000 uncompensated workers will give birth to %.1f babies.\n", 
			1000.0*uwbrate));
	pr(fmt("In one time unit, 1000 people eat %.1f units of food.\n", 
			1000.0*eatrate));
	pr(fmt("1000 babies eat %.1f units of food becoming adults.\n", 
			1000.0*babyeat));
	pr("\n");

	pr(fmt("Banks pay $%.2f in interest per 1000 gold bars per etu.\n",
		bankint*1000.0));
	pr(fmt("1000 civilians generate $%.2f, uncompensated workers $%.2f each time unit.\n", 1000.0*money_civ, 1000.0*money_uw));
	pr(fmt("1000 active military cost $%.2f, reserves cost $%.2f.\n",
		-money_mil*1000.0, -money_res*1000.0));
	pr("\n");

	pr(fmt("Happiness p.e. requires 1 happy stroller per %d civ.\n",
		(int) hap_cons));
	pr(fmt("Education p.e. requires 1 class of graduates per %d civ.\n",
		(int) edu_cons));
	pr(fmt("Happiness is averaged over %d time units.\n", (int)hap_avg));
	pr(fmt("Education is averaged over %d time units.\n", (int)edu_avg));
	pr(fmt(
	"The technology/research boost you get from your allies is %.2f%%.\n",
		100.0/ally_factor));
	pr(fmt("Nation levels (tech etc.) decline 1%% every %d time units.\n",
		(int)(level_age_rate)));

	pr("Tech Buildup is ");
	if (tech_log_base <= 1.0 && hard_tech == 0.0) {
		pr("not limited\n");
	} 
	if (tech_log_base > 1.0) {
		pr(fmt("limited to logrithmic growth (base %.2f)",
			tech_log_base));
		if (easy_tech + tech_log_base == 0.0) 
			pr(".\n");
		else
			pr(fmt(" after %0.2f.\n", easy_tech + tech_log_base));
	} else {
		pr(fmt("limited to asymptotic growth towards %.2f",
			hard_tech + easy_tech));
		if (easy_tech == 0.00) 
			pr(".\n");
		else
			pr(fmt("after %.2f\n",easy_tech));
	}
	pr("\n");

    pr("Market type is ");
#ifdef TRADECENTERS
    pr("Trade centers.\n");
#ifdef TRADECENTERISAIRPORT
    pr("  Trade centers may be used as airports.\n");
#endif
#ifdef TRADEONLYINCENTERS
    pr("  All transactions must happen in trade centers except:\n"); i=0;
#ifdef TELEPORTPLANES
    pr("    planes and nukes may be teleported\n"); i=1;
#endif
#ifdef TRADESHIPSANYWHERE
    pr("    ships can be traded anywhere\n"); i=1;
#endif
#ifdef TANKS
#ifdef TRADETANKSANYWHERE
    pr("    tanks can be traded anywhere\n"); i=1;
#endif
#endif
#ifdef BALLOONS
#ifdef TRADEBALLOONSANYWHERE
    pr("    balloons can be traded anywhere\n"); i=1;
#endif
#endif
#ifdef TRAINS
#ifdef TRADETRAINSANYWHERE
    pr("    trains can be traded anywhere\n"); i=1;
#endif
#endif
#ifdef PLANES
#ifdef TRADEPLANESANYWHERE
    pr("    planes can be traded anywhere\n"); i=1;
#endif
#endif
#ifdef NUKES
#ifdef TRADENUKESANYWHERE
    pr("    nukes can be traded anywhere\n"); i=1;
#endif
#endif
    if (i==0) pr("    (no exceptions)\n");
#endif
#else
    pr("Teleport.\n");
#endif
    pr("\n");

    pr(fmt("Max sector mobility is %d; sectors gain %d mob/update.\n",
	   sect_mob_max,etu_per_update*sect_mob_scale));
    pr(fmt("Max ship mobility is %d; ships gain %d mob/update.\n",
	   ship_mob_max,etu_per_update*ship_mob_scale));
#ifdef PLANES
    pr(fmt("Max plane mobility is %d; planes gain %d mob/update.\n",
	   plane_mob_max,etu_per_update*plane_mob_scale));
#endif
#ifdef SPIES
    pr(fmt("Max spy mobility is %d; spies gain %d mob/update.\n",
	   spy_mob_max,etu_per_update*spy_mob_scale));
#endif
    pr("\n");
    
    if (wastetime==255)
	pr("Wasteland is permanent.\n");
    else if (wastetime==254)
	pr("Wasteland becomes usable after 5-30 updates.\n");
    else if (wastetime==0)
	pr("Wasteland becomes usable at the next update.\n");
    else
	pr(fmt("Wasteland becomes usable after %d-%d updates.\n",
		wastetime-1,wastetime+1));
    pr("\n");

#ifdef SHIPSNEEDPET
    pr("Ship and vehicle petrol requirements are in effect.\n");
    pr("\n");
#endif

    if (explorecost > 0.0)
	pr(fmt("Exploration costs $%.2f per sector, and requires at least:\n",
	       explorecost));
    else 
	pr(fmt("Exploration costs nothing, but requires at least:\n"));
    pr(fmt("      %d civ (expending at least %.1f mob/sector)\n",
	   civexplore,civexploremob));
    pr(fmt("or    %d mil (expending at least %.1f mob/sector).\n",
	   milexplore,milexploremob));
    pr("\n");
    
    pr(fmt("Bunker construction cost is $%.2f per occupant.\n",
	   bunker_cost));
    pr(fmt("Bunker strength against non-pinpoint damage is %.2f.\n",
	   bunker_strength));
    pr("\n");

#ifdef SPIES
    pr(fmt("Spy searches cost $%.2f per mil per sector.\n",searchcost));
    pr(fmt("Spy liquidation cleanup and paperwork costs $%.2f.\n",killcost));
    pr(fmt("Spy capture and reprogramming costs $%.2f.\n",capturecost));
    pr(fmt("Spies retire with a $%.2f pension after %d updates (%d etus).\n",
	   retire_pay,spy_retire/etu_per_update,spy_retire));
    pr("\n");
#endif

#ifdef LOTTERY
    pr(fmt("Lotto tickets cost $%d.\n",LOTTOTICKET));
    pr("\n");
#endif

    pr(fmt("The person to annoy if something goes wrong is %s\n\t\t(%s).\n",
	   privname, privlog));
    pr(fmt("You can get your own copy of the source %s\n",GET_SOURCE));
    return RET_OK;
}
