#ifndef lint
static char *RCSid = "$Header: natarg.c,v 1.1 89/12/14 13:28:23 jay Exp $";
#endif

/*
 * natarg.c
 *
 * return country # given country name or
 * country #.
 *
 * from PSL Empire, 1985
 */

#include <ctype.h>
#include "misc.h"
#include "nat.h"

int
natarg(arg, prompt)
	char	*arg;
	char	*prompt;
{
	int	n;

	arg = getstarg(arg, prompt);
	if (arg == 0 || *arg == 0)
		return -1;
	if (isdigit(*arg))
		n = atoi(arg);
	else
		n = cnumb(arg);
	if (n < 0 || n >= MAXNOC) {
		pr("No such country exists.\n");
		n = -1;
	}
	return n;
}

/* ___________________________________________________________________
**|                                                                   |
**| natorsectarg(arg, prompt) -                                       |
**|                                                                   |
**| Given country name, country number, sector, range or realm,       |
**| this routine returns:                                             |
**|                                                                   |
**|   >= 0     country number                                         |
**|   = -1     invalid or missing argument                            |
**|   = -2     ALL countries ('*')                                    |
**|   = -3     argument can be reparsed as a sector, range or realm   |
**|___________________________________________________________________|
*/

int natorsectarg(arg, prompt)
char *arg;
char *prompt;
{
    int n;
    arg = getstarg(arg, (prompt && *prompt) ?
	       prompt : "(country or sector)? ");
    if (!(arg && *arg)) return -1;
    while (*arg && *arg<=' ') arg++;
    if (!*arg) return -1;
    if (*arg == '*') return -2;
    if (*arg == '.') return cnum;
    if (((*arg=='-' || isdigit(*arg)) && strchr(arg,','))
	|| (*arg=='#')) return -3;
    return natarg(arg,"");
}
