#ifndef lint
static char *RCSid = "$Header: plnsub.c,v 1.1 89/12/14 13:28:29 jay Exp $";
#endif

/*
 * plnsub.c
 *
 * Plane subroutine stuff
 *
 * Dave Pare, 1986
 * 4/12/91 bf@hp - added helicopter (special case VTOL) support
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "item.h"
#include "plane.h"
#include "nuke.h"
#include "deity.h"
#include "xy.h"
#include "nsc.h"
#include "news.h"
#include "file.h"
#include "loc.h"
#include "nat.h"
#include "path.h"

getassemblypoint(s,t,x,y)
char *s,*t;
coord *x,*y;
{
    char *p;
    int i,haveplane;
    struct nstr_item ni;
    struct plnstr plane;
    struct sctstr apsect;
    haveplane = (s && *s);
    p = getstarg(t, "assembly point (or '.')? ");
    if (p==0 || *p==0) return 0;
    if (*p=='.') {
	if (!haveplane)
	    pr("specify a plane number at assembly point\n");
        if (!snxtitem(&ni, EF_PLANE,s)) return 0;
	if (!nxtitem(&ni,(char *)&plane)) return 0;
        if (!god && plane.pln_own!=cnum) return 0;
	*x = plane.pln_x;
	*y = plane.pln_y;
	pr(fmt("assembly point @ %s\n",xyas(*x,*y,cnum)));
	return 1;
    }
    return(sarg_xy(p,x,y));
}

int pln_onewaymission(target, shipno, flagp)
struct sctstr *target;
int *shipno,*flagp;
{
    int	canlandinsect,canlandonship;
    int nships,cno,flags,n,r;
    struct shpstr ship;
    struct mchrstr *mp;
    char *p;

    flags = *flagp;
    dpr(fmt("pln_onewaymission: entered with flags=%d",flags));

    canlandinsect = canlandonship = 0;
    
    if (target->sct_own && target->sct_own!=cnum) {
	r = getrel(getnatp(target->sct_own),cnum);
#ifdef USEALLIEDAIRPORTS
	if (!canlandinsect) canlandinsect = (r==ALLIED);
#endif
#ifdef USENEUTRALAIRPORTS
	if (!canlandinsect) canlandinsect = (r==NEUTRAL);
#endif
#ifdef USEHOSTILEAIRPORTS
	if (!canlandinsect) canlandinsect = (r==HOSTILE);
#endif
#ifdef USEENEMYAIRPORTS
	if (!canlandinsect) canlandinsect = (r==AT_WAR);
#endif
	if (!canlandinsect) {
	    pr(fmt("You can't land there!\n"));
	    return -1;
	}
    } else {
	canlandinsect = (target->sct_own==cnum);
    }

    if (target->sct_type == SCT_MOUNT) {
	pr("Planes can't land in mountains!\n");
	return -1;
    }

    cno = -1;
    
    if (canlandinsect) {
#ifdef TRADECENTERISAIRPORT
	if (target->sct_type!=SCT_AIRPT && target->sct_type!=SCT_TRADE) {
	    pr("Destination isn't an airport or trade center.\n");
#else
        if (target->sct_type != SCT_AIRPT) {
	    pr("Destination isn't an airport.\n");
#endif
	    flags |= (P_V|P_H); /* plane will need VTOL or HELI capability */
	} else if (target->sct_effic < 60) {
	    pr("Destination airport not up to 60% efficiency.\n");
	    flags |= (P_V|P_H); /* plane will need VTOL or HELI capability */
	}
    }
    
/*
#ifdef TRADECENTERS
    if (target->sct_type == SCT_WATER ||
	target->sct_type == SCT_HARBR ||
	target->sct_type == SCT_TRADE ) {
#else
    if (target->sct_type == SCT_WATER ||
	target->sct_type == SCT_HARBR ) {
#endif
*/
	nships = shipsatxy(target->sct_x,target->sct_y,M_FLY|M_HELI|M_VTOL,0);
	dpr(fmt("pln_onewaymission: %d ships in target sector",nships));
	if (nships<=0 && !canlandinsect) {
	    if (target->sct_type == SCT_WATER)
		pr(fmt("There's nothing to land on in %s!\n",
		       xyas(target->sct_x, target->sct_y, cnum)));
	    else
		pr(fmt("You can't land anywhere in %s!\n",
		       xyas(target->sct_x, target->sct_y, cnum)));
	    return -1;
	}

	if (nships > 0) while (cno < 0) {

	    p=getstring("Carrier/Platform # ('.' for current sector)? ");
	    if (!p || !*p || *p == '.') {
		dpr("pln_onewaymission: using current sector");
		break;
	    }
	    n = atoi(p);
	    dpr(fmt("pln_onewaymission: n=%d",n));

	    if (n < 0 || !getship(n, &ship)) continue;
	    
	    canlandonship = owner;
	    r = (int)getrel(getnatp(ship.shp_own),cnum);
#ifdef USENEUTRALCARRIERS
	    if (!canlandonship)	canlandonship = (r==NEUTRAL);
#endif
#ifdef USEALLIEDCARRIERS
	    if (!canlandonship)	canlandonship = (r==ALLIED);
#endif
	    if (!canlandonship) {
		pr("You're can't land there\n");
		continue;
	    }
	    
	    mp = &mchr[ship.shp_type];
	    if (ship.shp_x != target->sct_x ||
		ship.shp_y != target->sct_y) {
		pr(fmt("%s #%d not in %s\n", 
		       mp->m_name, n,
		       xyas(target->sct_x, target->sct_y, cnum)));
		continue;
	    }
	    if (mp->m_flags & (M_FLY|M_VTOL|M_HELI) == 0) {
		pr(fmt("Can't land on %s #%d.\n", mp->m_name, n));
		continue;
	    }
   	    if (ship.shp_nplane >= mp->m_maxplns) {
		pr(fmt("No room on %s #%d.\n", mp->m_name, n));
		continue;
	    }
	    cno = n;
	    flags &= ~(P_H|P_V|P_L);
	    if (mp->m_flags & M_HELI) flags |= P_H;
	    if (mp->m_flags & M_VTOL) flags |= P_V;
	    if (mp->m_flags & M_FLY)  flags |= P_L;
	}

/*
    }
*/

    dpr(fmt("pln_onewaymission: returning 0, cno=%d, flags=%d [ %s%s%s]", 
	    cno, flags,
	    flags & P_H ? "Heli " : " ",
	    flags & P_V ? "Vtol " : " ",
	    flags & P_L ? "Light " : " "));
    *shipno = cno;
    *flagp = flags;
    return 0;
}

int enginefail(uid)
int uid;
{
    int i;
    pr(fmt("  #%d engine ",uid));
    switch (roll(3)) {
    case 1: pr("fire!\n"); i=30; break;
    case 2: pr("failure!\n"); i=20; break;
    case 3: pr("malfunction!\n"); i=10; break;
    }
    return roll(i);
}
    
pln_newlanding(list, tx, ty, cno)
struct qelem *list;
coord tx, ty;
int cno;
{
    struct qelem *qp;
    struct plist *plp;
    struct shpstr ship;
    int np,mishap,i;
    
    if (cno >= 0) getship(cno, &ship);
    np = 0;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *)qp;
	plp->plane.pln_x = tx;
	plp->plane.pln_y = ty;

	if (cno < 0) {
	    plp->plane.pln_ship = -1;
	    pr(fmt("  #%d landing in %s\n",
		   plp->plane.pln_uid,xyas(tx,ty,cnum)));
	fieldapproach:
	    mishap = (chance(0.02) ? roll(2) : 0);
	    switch (mishap) {
	    case 1:
		pr(fmt("  #%d missed approach, going around ...\n",
		       plp->plane.pln_uid));
		goto fieldapproach;
	    case 2:
		plp->plane.pln_effic -= enginefail(plp->plane.pln_uid);
		goto fieldapproach;
	    }
	}

	else {
	    if (!np++) 
		pr(fmt("%s #%d reports %d aircraft aboard, room for %d more\n",
		       mchr[ship.shp_type].m_name, cno,
		       ship.shp_nplane,
		       mchr[ship.shp_type].m_maxplns-ship.shp_nplane
		       ));
	shipapproach:
	    mishap = (ship.shp_nplane>=mchr[ship.shp_type].m_maxplns) ? 5
		: (chance(0.05) ? roll(4) : 0);
	    switch (mishap) {
	    case 1:
		pr(fmt("  #%d missed approach, going around ...\n",
		       plp->plane.pln_uid));
		goto shipapproach;
	    case 2:
		pr(fmt("  #%d waved off, going around ...\n",
		       plp->plane.pln_uid));
		goto shipapproach;
	    case 3:
		if (plp->plane.pln_effic -= enginefail(plp->plane.pln_uid)
		    < 10) pr(fmt("  #%d goes down\n",plp->plane.pln_uid));
		goto shipapproach;
	    case 4:
		pr(fmt("  #%d botched approach, ",plp->plane.pln_uid));
		if (chance(0.1)) {
		    if (chance(0.5)) pr("goes over the side!\n");
		    else pr("crashes on deck!\n");
		    plp->plane.pln_effic = 0;
		} else {
		    pr("going around ...\n");
		    goto shipapproach;
		}
		break;
	    case 5:
		pr(fmt("  No room to land!  #%d goes down!\n",
		       plp->plane.pln_uid));
		plp->plane.pln_effic = 0;
		if (ship.shp_own != cnum) {
		    wu(0,ship.shp_own,
		       fmt("%s %s #%d crashed landing on your %s #%d.\n",
			   cname(plp->plane.pln_own),
			   plchr[plp->plane.pln_type].pl_name,
			   plp->plane.pln_uid,
			   mchr[ship.shp_type].m_name,
			   cno));
		}
		break;
	    }
	    if (!mishap && plp->plane.pln_effic>=10) {
		pr(fmt("  #%d lands on deck.\n",plp->plane.pln_uid));
		ship.shp_nplane++;
		plp->plane.pln_ship = cno;
		if (ship.shp_own != cnum) {
		    wu(0,ship.shp_own,
		       fmt("%s %s #%d landed safely on your %s #%d.\n",
			   cname(plp->plane.pln_own),
			   plchr[plp->plane.pln_type].pl_name,
			   plp->plane.pln_uid,
			   mchr[ship.shp_type].m_name,
			   cno));
		}
	    }
	}
    }
    if (cno >= 0) {
	putship(cno, &ship);
	if (np) pr(fmt("%s #%d now reports %d aircraft aboard\n",
		       mchr[ship.shp_type].m_name, cno,
		       ship.shp_nplane
		       ));
    }
}

pln_dropoff(list, ip, tx, ty, ptr, type)
struct	qelem *list;
struct	ichrstr *ip;
coord	tx, ty;
char	*ptr;
int	type;
{
    int	amt,there,max;
    struct qelem *qp;
    struct plist *plp;
    struct shpstr *ship;
    struct mchrstr *mp;
    struct sctstr *sp;

    if (ip == 0) return;
    amt = 0;
    for (qp = list->q_forw; qp != list; qp = qp->q_forw) {
	plp = (struct plist *)qp;
	amt += plp->misc;
    }
    
    /* calc new amt aboard */
    there = getvar(ip->i_vtype, ptr, type) + amt; 
    max = 32767;
    
    if (type == EF_SHIP) {
	ship = (struct shpstr *) ptr;
	mp = &mchr[ship->shp_type];
	max = vl_find(ip->i_vtype, mp->m_vtype, /* max amt can hold */
		      mp->m_vamt, (int)mp->m_nv);
    }
    
    if (there > max) { /* if new amt aboard exceeds max amt can hold ... */
	
	/* the original code is wrong:
	   pr(fmt("%d excess %s discarded\n",max-there, ip->i_name));
	   amt = max - there;
	   there = max;
	   */
	pr(fmt("%d excess %s discarded\n",there-max,ip->i_name));
	amt -= (there-max);
	there = max;
	
    }
    putvar(ip->i_vtype, there, ptr, type);
    pr(fmt("%d %s landed safely", amt, ip->i_name));
    if (type == EF_SECTOR) {
	pr(fmt(" at %s\n", xyas(tx, ty, cnum)));
	sp = (struct sctstr *)ptr;
	putsect(sp);
#ifdef DROPANY
	if (sp->sct_own && sp->sct_own!=cnum)
	    wu(0,sp->sct_own,
	       fmt("%s airdrop landed %d %s in %s",
		   cname(cnum),amt,ip->i_name,xyas(tx,ty,sp->sct_own)));
#endif
    } else {
	pr(fmt(" on %s #%d\n",
	       mchr[ship->shp_type].m_name,
	       ship->shp_uid));
	putship(ship->shp_uid, ship);
    }
}

pln_sel(ni, list, ap, ap_to_target, rangemult, wantflags, nowantflags, ktarg)
struct nstr_item *ni;
struct qelem *list;
struct sctstr *ap;
int ap_to_target;
int rangemult;
int wantflags;
int nowantflags;
char *ktarg;
{
    struct plnstr plane;
    struct shpstr ship;
    struct sctstr sect;
    int	range;
    struct plchrstr *pcp;
    struct plist *plp;
    int i,j,k;
    char ps[80],*kk;

    initque(list);
    while (nxtitem(ni, (char *)&plane)) {

	if (!owner || plane.pln_mobil<=0)  continue;

	if (plane.pln_flags & PLN_BOXED) {
	    pr(fmt("%d is disassembled and crated\n",ni->cur));
	    continue;
	}

	range = mapdist(plane.pln_x, plane.pln_y, ap->sct_x, ap->sct_y);
	if (range > 4) {
	    pr(fmt("%d too far from assembly point\n", ni->cur));
	    continue;
	}
	range += ap_to_target;

	pcp = &plchr[plane.pln_type];
	if (wantflags) {
	    /* Mutually exclusive heli and vtol make this complicated */
	    i = pcp->pl_flags;
	    j = wantflags;
	    k = (P_H|P_V);
	    if ((j & k) == k) {
		if ((i & k) == 0) continue;
		i &= ~k;
		j &= ~k;
	    }
	    if ((i & j) != j) continue;
	}
	if (nowantflags)
	    if ((pcp->pl_flags & nowantflags)) continue;
	range *= rangemult;

	if (plane.pln_range < range) {
	    pr(fmt("%d out of range (%d:%d)\n", ni->cur,
		   plane.pln_range, range));
	    continue;
	}

	if (!pln_oktotakeoff(&plane)) continue;

	plp = (struct plist *) malloc(sizeof(struct plist));
	plp->state = P_OK;
	plp->misc = 0;
	plp->bombs = 0;
	plp->kamikaze = -1;
	plp->pcp = pcp;

	strcpy(ps, fmt("(#%d) %s standing by", 
		       ni->cur, plchr[plane.pln_type].pl_name));

	if (ktarg && *ktarg=='!') {
	    plp->kamikaze = -2;
	    pr(fmt("%s (kamikaze)\n",ps));
	}

	else if (!ktarg || !*ktarg || *ktarg=='.') {
	    pr(fmt("%s\n",ps));
	}

	else if (isdigit(*ktarg)) {
	    plp->kamikaze = atoi(ktarg);
	    pr(fmt("%s (target #%d)\n",ps));
	}

	else {

	plankktarget:

	    kk = getstring(fmt("%s; kamikaze? ",ps));

	    if (kk && (*kk=='!' || *kk=='y')) {
		plp->kamikaze = -2;
		if (*ktarg=='!') ktarg = "!";
	    }

	    else if (!kk || !*kk || *kk=='.' || *kk=='n') {
		if (*kk=='.') ktarg = ".";
	    }

	    else if (isdigit(*kk)) {
		plp->kamikaze = atoi(kk);
	    }
	
	    else {
		pr("Specify:\n");
		pr("  <y>        plane is a kamikaze\n");
		pr("  <n>/<Ret>  plane is not a kamikaze\n");
		pr("  <!>        this & all remaining planes are kamikazes\n");
		pr("  <.>        this & all remaining planes are not kamikazes\n");
		pr("  <id#>      plane is a kamikaze for target <id#>\n");
		goto plankktarget;
	    }
	}

	bcopy((char *)&plane, (char *)&plp->plane,
	      sizeof(struct plnstr));
	insque(&plp->queue, list);
    }
}

int pln_arm(list, mission, ip, flags, mission_flags)
struct qelem *list;
int mission;
struct ichrstr *ip;
int flags;
int mission_flags;
{
    struct qelem *qp;
    struct qelem *next;
    struct plist *plp;
    int	tech;
    int mobcost;
    
    tech = mission_flags >> 16;
    for (qp = list->q_forw; qp != list; qp = next) {
	next = qp->q_forw;
	plp = (struct plist *) qp;
	if (pln_equip(plp, ip, flags, mission) < 0) {
	    remque(qp);
	    free((char *)qp);
	    continue;
	}
	if (flags & (P_S|P_I|P_U|P_MS)) {
	    if(plp->pcp->pl_flags & P_S)  mission_flags |= P_S;
	    if(plp->pcp->pl_flags & P_I)  mission_flags |= P_I;
	    if(plp->pcp->pl_flags & P_U)  mission_flags |= P_U;
	    if(plp->pcp->pl_flags & P_MS) mission_flags |= P_MS;
	}
	if (plp->pcp->pl_flags & P_X) {
	    if (tech > plp->plane.pln_tech)
		tech = plp->plane.pln_tech;
	} else {
	    /* no stealth on this mission */
	    mission_flags &= ~P_X;
	}

	mobcost = (flags & P_F) ? 12 : 20;
	mobcost *= (1 + (100 - plp->plane.pln_effic) / 50);
	plp->plane.pln_mobil -= mobcost;

	pr(fmt("(#%d) %s equipped and airborne\n", plp->plane.pln_uid,
	       plp->pcp->pl_name));
    }
    mission_flags &= 0x0000ffff;
    mission_flags |= (tech << 16);
    return mission_flags;
}

int pln_equip(plp, ip, flags, mission)
struct plist *plp;
struct ichrstr *ip;
int flags;
char mission;
{
    int	item,needed,type,rval,vec[I_MAX+1];
    register struct plchrstr *pcp;
    struct plnstr *pp;
    struct shpstr ship;
    struct sctstr sect;
    char *ptr;

    pp = &plp->plane;
    pcp = plp->pcp;
    if (pp->pln_ship >= 0) {
	getship(pp->pln_ship, &ship);
	type = EF_SHIP;
	dpr(fmt("pln_equip: #%d takeoff from ship #%d",
		pp->pln_uid,ship.shp_uid));
	ptr = (char *) &ship;
    } else {
	getsect(pp->pln_x, pp->pln_y, &sect);
	type = EF_SECTOR;
	dpr(fmt("pln_equip: #%d takeoff from sector %s",
		pp->pln_uid,xyas(sect.sct_x,sect.sct_y,cnum)));
	ptr = (char *) &sect;
    }
    getvec(VT_ITEM, vec, ptr, type);
    dpr(fmt("pln_equip: need %d fuel",pcp->pl_fuel));
    dpr(fmt("pln_equip: %d available",vec[I_PETROL]));
    if (pcp->pl_fuel > vec[I_PETROL]) {
	pr(fmt("(#%d) %s not enough petrol there!\n",
	       pp->pln_uid, plp->pcp->pl_name));
	return -1;
    }
    vec[I_PETROL] -= pcp->pl_fuel;
    rval = 0;
    if ((flags & P_F) == 0) {
	item = 0;
	needed = 0;
	switch (mission) {
	case 's':
	case 'p':
	    item = I_SHELL;
	    needed = pcp->pl_load;
	    break;
	case 't':
	    if ((pcp->pl_flags & P_C) == 0 || ip == 0) break;
	    item = ip - ichr;
	    needed = (pcp->pl_load * 2) / ip->i_lbs;
	    break;
	case 'd':
	    if ((pcp->pl_flags & P_C) == 0 || ip == 0) break;
	    item = ip - ichr;
	    needed = (pcp->pl_load * 2) / ip->i_lbs;
	    break;
	case 'a':
	    if ((pcp->pl_flags & (P_V|P_H|P_C)) == 0) break;
	    item = I_MILIT;
	    needed = pcp->pl_load / ip->i_lbs;
	    break;
	case 'n':
	    if (pp->pln_nukeamt == 0) rval = -1;
	    break;
	case 'r': /* recon */
	case 'w': /* sweep */
	default:
	    break;
	}
	if (rval < 0 || (item && needed <= 0)) {
	    pr(fmt("%s #%d can't contribute to mission\n",
		   pcp->pl_name, pp->pln_uid));
	    return -1;
	}
	if (vec[item] < needed) {
	    pr(fmt("Not enough %s for plane #%d\n",
		   ichr[item].i_name, pp->pln_uid));
	    return -1;
	} else {
	    vec[item] -= needed;
	}
	if (item == I_SHELL && (mission == 's' || mission == 'p'))
	    plp->bombs = needed;
	else
	    plp->misc = needed;
    }
    putvec(VT_ITEM, vec, ptr, type);
    if (type != EF_SHIP) putsect(&sect);
    else {
	/* subtract a plane from the ship and do a sanity check */
	ship.shp_nplane--;
	if (ship.shp_nplane < 0) {
	    logerror(
		     "pln_equip: country #%d: removing plane %d from ship %d, %d planes remain.\n",
		     cnum,pp->pln_uid,ship.shp_uid,ship.shp_nplane);
	    ship.shp_nplane = 0;
	}
	putship(ship.shp_uid, &ship);
    }
    return rval;
}

pln_unequip(list)
struct qelem *list;
{
    /* Unload undropped bombs from planes after a mission */
    register struct qelem *qp;
    register struct qelem *newqp;
    struct plist *plp;
    struct sctstr sect;
    struct shpstr ship;
    int vec[I_MAX+1];
    for (qp=list->q_forw; qp!=list; qp=qp->q_forw) {
	plp = (struct plist *) qp;
	if (plp->bombs && plp->plane.pln_own && plp->plane.pln_effic>10) {
	    pr(fmt("(#%d) %s unloading %d unused bombs ",
		   plp->plane.pln_uid,plchr[plp->plane.pln_type].pl_name,
		   plp->bombs));
	    if (plp->plane.pln_ship < 0) {
		if (getsect(plp->plane.pln_x,plp->plane.pln_y,&sect)) {
		    getvec(VT_ITEM, vec, &sect, EF_SECTOR);
		    vec[I_SHELL] += plp->bombs;
		    putvec(VT_ITEM, vec, &sect, EF_SECTOR);
		    putsect(&sect);
		    pr(fmt("@ %s\n",xyas(sect.sct_x,sect.sct_y,cnum)));
		}
	    } else {
		if (getship(plp->plane.pln_ship,&ship)) {
		    getvec(VT_ITEM, vec, &ship, EF_SHIP);
		    vec[I_SHELL] += plp->bombs;
		    putvec(VT_ITEM, vec, &ship, EF_SHIP);
		    putship(ship.shp_uid,&ship);
		    pr(fmt("aboard %s\n",shipas(&ship,LS)));
		}
	    }
	}
    }
}

pln_put(list)
struct	qelem *list;
{
    register struct qelem *qp;
    register struct qelem *newqp;
    struct	plist *plp;
    
    qp = list->q_forw;
    while (qp != list) { 
	plp = (struct plist *) qp;
	putplane(plp->plane.pln_uid, &plp->plane);
	newqp = qp->q_forw;
	remque(qp);
	free((char *)qp);
	qp = newqp;
    }
}

pln_removedupes(bomb_list, esc_list)
struct	qelem *bomb_list;
struct	qelem *esc_list;
{
    struct	qelem *bomb;
    struct	qelem *esc;
    
    if (QEMPTY(bomb_list) || QEMPTY(esc_list))
	return;
    bomb = bomb_list->q_forw;
    esc = esc_list->q_forw;
    while (bomb != bomb_list) {
	if (QEMPTY(esc_list)) {
	    bomb = bomb_list;
	    continue;
	}
	esc = esc->q_forw;
	while (esc != esc_list) {
	    if (esc == bomb) {
		remque(esc);
		free((char *)esc);
		esc = esc_list;
	    } else
		esc = esc->q_forw;
	}
	bomb = bomb->q_forw;
    }
}


pln_oktotakeoff(plane)
struct plnstr *plane;
{
    struct shpstr ship;
    struct sctstr sect;
    struct plchrstr *pcp;

    pcp = &plchr[plane->pln_type];
    if (plane->pln_ship >= 0) {
	if (!getship(plane->pln_ship, &ship) || plane->pln_own != cnum) {
	shipsunk:
	    plane->pln_effic = 0;
	    pr(fmt("%s lost; invalid ship\n", planeas(plane,0)));
	    putplane(plane->pln_uid, &plane);
	    return 0;
	}
	if (ship.shp_effic < 20)  goto shipsunk;
	if (!planefitsship(pcp->pl_flags,mchr[ship.shp_type].m_flags)) goto shipsunk;
	if (ship.shp_effic < 50)  {
	    pr(fmt("%s can't fly; %s less than 50% efficient.\n",
		   planeas(plane,0),shipas(&ship,0)));
	    return 0;
	}
    }
    /*
    **  If not vtol or helicopter and not at an airport, you lose!
    */
    if (!(pcp->pl_flags & (P_V|P_H)) && (plane->pln_ship < 0)) {
#ifdef TRADECENTERISAIRPORT
	if (!getsect(plane->pln_x, plane->pln_y, &sect) ||
	    (sect.sct_type != SCT_TRADE && sect.sct_type!=SCT_AIRPT)) {
	    pr(fmt("%s not at an airport or trade center\n", planeas(plane,0)));
	    return 0;
	}
#else
	if (!getsect(plane->pln_x, plane->pln_y, &sect) ||
	    sect.sct_type != SCT_AIRPT) {
	    pr(fmt("%s not at an airport\n", planeas(plane,0)));
	    return 0;
	}
#endif
	if (sect.sct_effic < 40) {
	    pr(fmt("%s can't fly; sector less than 40% efficient.\n",
		   planeas(plane,0)));
	    return 0;
	}
    }
    return 1;
}
